#!/bin/bash
. /etc/openvpncertmgmt.conf


#if test `id -u` -ne 0; then
#	echo "Must be root to run this script"
#	exit 1;
#fi

SERVER=${1}
COUNTRY=${2}
PROVINCE=${3}
CITY=${4}
COMPANY=${5}
DEPT=${6}

EMAIL=${7}
NETWORK=${8}
NETMASK=${9}
PORT=${10}
DNSADDRESS=${11}
PROTOCOL=${12}
TUNTAP=${13}
DHBITS=${14}
CLIENT2CLIENT=${15}
CLIENTACCESS=${16}
DUPLICATECN=${17}
ROUTETO=${18}
BRIDGE=${19}
WINDOWS=${20}
POOLSTART=${21}
POOLEND=${22}

FASTIO=${23}
MULTIHOME=${24}
MTUDISC=${25}
MTUTEST=${26}
MSSFIX=${27}
FRAGMENT=${28}
VERB=${29}
MGMTADDR=${30}
MGMTPORT=${31}

KEYSIZE=$DHBITS

if test -f $OPENVPNHOME/easy-rsa/keys/${SERVER}.crt; then
	echo -n "SERVER crt already exists!  Exiting..."
	exit 1
fi

A=$OPENVPNHOME/easy-rsa
export EASY_RSA=$A
cd $A

mkdir -m 755 $A/keys/${SERVER}
touch $A/keys/${SERVER}/index.txt
touch $A/keys/${SERVER}/.rnd
chmod 600 $A/keys/${SERVER}/.rnd
echo "00" > $A/keys/${SERVER}/serial
chmod 644 $A/keys/${SERVER}/*

sed 's/<KEYCOUNTRY>/'"$COUNTRY"'/' vars.in |
    sed 's/<KEYPROVINCE>/'"$PROVINCE"'/' |
    sed 's/<PORT>/'"$PORT"'/' |
    sed 's/<PROTOCOL>/'"$PROTOCOL"'/' |
    sed 's/<TUNTAP>/'"$TUNTAP"'/' |
    sed 's/<DNSADDRESS>/'"$DNSADDRESS"'/' |
    sed 's/<KEYCITY>/'"$CITY"'/' |
    sed 's/<KEYSIZE>/'"$KEYSIZE"'/' |
    sed 's/<KEYORG>/'"$COMPANY"'/' |
    sed 's/<KEYOU>/'"$DEPT"'/' |
    sed 's/<KEYCN>/'"$SERVER"'/' |
    sed 's/<KEYEMAIL>/'"$EMAIL/"''>$A/keys/${SERVER}/vars
chmod +x $A/keys/${SERVER}/vars


echo ". $A/keys/${SERVER}/vars" >>/tmp/jbb
. $A/keys/${SERVER}/vars
export KEY_DIR="$A/keys/${SERVER}"
echo "key_dir" >>/tmp/jbb
echo $KEY_DIR >>/tmp/jbb

pwd >>/tmp/jbb
echo "./build-ca  --batch ${SERVER}" >>/tmp/jbb
echo "build-ca"
$EASY_RSA/build-ca --batch ${SERVER}

echo "./build-dh-server ${SERVER}" >>/tmp/jbb
echo "build-dh-server"
pwd >>/tmp/jbb
$A/build-dh-server  ${SERVER}

echo "./build-key-server --batch ${SERVER}" >>/tmp/jbb
echo "build-key-server"
$A/build-key-server --batch ${SERVER}

#    echo "./build-req --batch ${SERVER}" >>/tmp/jbb
#    echo "build-req"
#    ./build-req --batch ${SERVER}

#    echo "./sign-req --batch ${SERVER}" >>/tmp/jbb
#    echo "sign-req"
#    ./sign-req --batch ${SERVER}

$OPENVPNBIN --genkey --secret $A/keys/${SERVER}/ta.key
chmod +r $A/keys/${SERVER}/ta.key

$A/create-empty-crl ${SERVER}

rm -fr $OPENVPNHOME/openvpn/*
#mkdir $OPENVPNHOME/openvpn
mkdir $OPENVPNHOME/openvpn/${SERVER}

cd $OPENVPNHOME/servers

#
# Conf file
#

cp $OPENVPNHOME/scripts/Server.conf.in $OPENVPNHOME/servers/${SERVER}.conf

if [ "$BRIDGE" = "yesProxy" ]; then
    sed -i "s/<BRIDGE>/-bridge/g" $OPENVPNHOME/servers/${SERVER}.conf
fi
if [ "$BRIDGE" = "yesNogw" ]; then
    sed -i "s/<BRIDGE>/-bridge/g" $OPENVPNHOME/servers/${SERVER}.conf
    sed -i "s/<NETWORK>/'nogw'/g" $OPENVPNHOME/servers/${SERVER}.conf
    sed -i "s/<NETMASK>//g" $OPENVPNHOME/servers/${SERVER}.conf
    sed -i "s/<POOL-START>//g" $OPENVPNHOME/servers/${SERVER}.conf
    sed -i "s/<POOL-END>//g" $OPENVPNHOME/servers/${SERVER}.conf
fi
if [ "$BRIDGE" = "yes" ]; then
    sed -i "s/<BRIDGE>/-bridge/g" $OPENVPNHOME/servers/${SERVER}.conf
    sed -i "s/<POOL-START>/${POOLSTART}/g" $OPENVPNHOME/servers/${SERVER}.conf
    sed -i "s/<POOL-END>/${POOLEND}/g" $OPENVPNHOME/servers/${SERVER}.conf
else
    [ "$POOLSTART" != "" ] && sed -i "s/<IFCONFIG-POOL-START>/${POOLSTART}/g" $OPENVPNHOME/servers/${SERVER}.conf
    [ "$POOLEND" != "" ] && sed -i "s/<IFCONFIG-POOL-END>/${POOLEND}/g" $OPENVPNHOME/servers/${SERVER}.conf    
    [ "$POOLSTART" != "" -o "$POOLEND" != "" ] && sed -i "s/#<IFCONFIG-POOL>/ifconfig-pool/" $OPENVPNHOME/servers/${SERVER}.conf    
#fi
#if [ "$BRIDGE" = "no" ]; then
    sed -i "s/<BRIDGE>//g" $OPENVPNHOME/servers/${SERVER}.conf
    sed -i "s/<POOL-START>//g" $OPENVPNHOME/servers/${SERVER}.conf
    sed -i "s/<POOL-END>//g" $OPENVPNHOME/servers/${SERVER}.conf
fi

sed -i "s/<SERVER>/${SERVER}/g" $OPENVPNHOME/servers/${SERVER}.conf
sed -i "s/<NETWORK>/${NETWORK}/g" $OPENVPNHOME/servers/${SERVER}.conf
sed -i "s/<NETMASK>/${NETMASK}/g" $OPENVPNHOME/servers/${SERVER}.conf
sed -i "s/<PORT>/${PORT}/g" $OPENVPNHOME/servers/${SERVER}.conf

if [ "$OPENVPNVERSION_21" = "yes" ]; then
    sed -i "s/<2.1>//g" $OPENVPNHOME/servers/${SERVER}.conf
else
    sed -i "s/<2.1>/# Openvpn 2.1 and above: /g" $OPENVPNHOME/servers/${SERVER}.conf
fi



if [ "$WINDOWS" = "yes" ]; then
    sed -i "s/<NOWINDOWS>/# /g" $OPENVPNHOME/servers/${SERVER}.conf
else 
    sed -i "s/<NOWINDOWS>//g" $OPENVPNHOME/servers/${SERVER}.conf
fi

#sed -i "s/<DHBITS>/${DHBITS}/g" $OPENVPNHOME/servers/${SERVER}.conf

if [ "$CLIENT2CLIENT" = "yes" ]; then sed -i "s/<CLIENT2CLIENT>//g" $OPENVPNHOME/servers/${SERVER}.conf
else sed -i "s/<CLIENT2CLIENT>/# /g" $OPENVPNHOME/servers/${SERVER}.conf
fi

if [ "$DUPLICATECN" = "yes" ]; then sed -i "s/<DUPLICATECN>//g" $OPENVPNHOME/servers/${SERVER}.conf
else sed -i "s/<DUPLICATECN>/# /g" $OPENVPNHOME/servers/${SERVER}.conf
fi

sed -i "s/<PROTOCOL>/${PROTOCOL}/g" $OPENVPNHOME/servers/${SERVER}.conf
sed -i "s/<TUNTAP>/${TUNTAP}/g" $OPENVPNHOME/servers/${SERVER}.conf

sed -i "s/<VERB>/${VERB}/g" $OPENVPNHOME/servers/${SERVER}.conf

sed -i "s/<MGMTADDR>/${MGMTADDR}/g" $OPENVPNHOME/servers/${SERVER}.conf
sed -i "s/<MGMTPORT>/${MGMTPORT}/g" $OPENVPNHOME/servers/${SERVER}.conf
if [ "$MGMTPORT" != "" ]; then
sed -i "s/<MGMTCMT>//g" $OPENVPNHOME/servers/${SERVER}.conf
else
sed -i "s/<MGMTCMT>/# /g" $OPENVPNHOME/servers/${SERVER}.conf
fi

#
# Advanced Options
#
[ "$FASTIO" = "yes" ] && sed -i "s/#<FASTIO>/fast-io/" $OPENVPNHOME/servers/${SERVER}.conf
[ "$MULTIHOME" != "no" ] && sed -i "s/#<MULTIHOME>/multihome/" $OPENVPNHOME/servers/${SERVER}.conf
[ "$MTUDISC" != "kernel" ] && sed -i "s/#<MTU-DISCOVERY>/mtu-disc $MTUDISC/" $OPENVPNHOME/servers/${SERVER}.conf
[ "$MTUTEST" = "yes" ] && sed -i "s/#<MTU-TEST>/mtu-test/" $OPENVPNHOME/servers/${SERVER}.conf
[ "$MSSFIX" != "no" ] && sed -i "s/#<MSSFIX>/mssfix $MSSFIX/" $OPENVPNHOME/servers/${SERVER}.conf
[ "$FRAGMENT" != "no" ] && sed -i "s/#<FRAGMENT>/fragment $FRAGMENT/" $OPENVPNHOME/servers/${SERVER}.conf

# The following just cleans out any unused options from the file.
sed -i "s/#<FASTIO>//" $OPENVPNHOME/servers/${SERVER}.conf
sed -i "s/#<MULTIHOME>//" $OPENVPNHOME/servers/${SERVER}.conf
sed -i "s/#<MTU-DISCOVERY>//" $OPENVPNHOME/servers/${SERVER}.conf
sed -i "s/#<MTU-TEST>//" $OPENVPNHOME/servers/${SERVER}.conf
sed -i "s/#<MSSFIX>//" $OPENVPNHOME/servers/${SERVER}.conf
sed -i "s/#<FRAGMENT>//" $OPENVPNHOME/servers/${SERVER}.conf




#
# Security files
#
# We don't copy the ca.key, that file stays here for security
for i in ca.crt dh-${SERVER}.pem ${SERVER}.key ${SERVER}.crt ta.key crl.pem; do
    cp $OPENVPNHOME/easy-rsa/keys/${SERVER}/$i $OPENVPNHOME/openvpn/${SERVER}
done

#
# Serverup.sh and Serverdown.sh
#
cp $OPENVPNHOME/scripts/serverup.sh.in $OPENVPNHOME/openvpn/${SERVER}/serverup.sh
cp $OPENVPNHOME/scripts/serverdown.sh.in $OPENVPNHOME/openvpn/${SERVER}/serverdown.sh

[ "$CLIENTACCESS" = "no" ] &&  echo 'iptables -A INPUT -i $1 -j REJECT' >>$OPENVPNHOME/openvpn/${SERVER}/serverup.sh

if [ "$ROUTETO" != "none" ]; then
    echo "echo 1 >/proc/sys/net/ipv4/ip_forward" >>$OPENVPNHOME/openvpn/${SERVER}/serverup.sh
    echo "iptables -A FORWARD -i \$1 -j ACCEPT -d $ROUTETO" >>$OPENVPNHOME/openvpn/${SERVER}/serverup.sh
    echo "iptables -D FORWARD -i \$1 -j ACCEPT -d $ROUTETO" >>$OPENVPNHOME/openvpn/${SERVER}/serverdown.sh
    
    sed -i "s/<PUSH-ROUTE>//" $OPENVPNHOME/servers/${SERVER}.conf
    $R=${ROUTETO%.*}
    sed -i "s/<ROUTETO>/$R.0/" $OPENVPNHOME/servers/${SERVER}.conf
else
    sed -i "s/<PUSH-ROUTE>/# /" $OPENVPNHOME/servers/${SERVER}.conf
fi
chmod +x $OPENVPNHOME/openvpn/${SERVER}/server*.sh


#
# Set up for Macs
#
cp $OPENVPNHOME/servers/${SERVER}.conf $OPENVPNHOME/servers/${SERVER}.mac.sh

#
# Set up for Windows
#
cp $OPENVPNHOME/servers/${SERVER}.conf $OPENVPNHOME/servers/${SERVER}.ovpn
/usr/bin/unix2dos $OPENVPNHOME/servers/${SERVER}.ovpn

sed -i "s/<#>//g" $OPENVPNHOME/servers/${SERVER}.conf
sed -i "s/<#>/#/g" $OPENVPNHOME/servers/${SERVER}.ovpn


#
# The install.sh is used for all Unixes
#

cd $OPENVPNHOME/tmp
cp $OPENVPNHOME/scripts/install.sh $OPENVPNHOME/tmp/
sed -i "s/<SERVER>/${SERVER}/g" $OPENVPNHOME/tmp/install.sh

#
# taptunadjust.  Goes in /etc/openvpn, is used during install and then deleted
#
dev=`expr substr $TUNTAP 1 3`
sed 's/<DEV>/'"$dev"'/' $OPENVPNHOME/scripts/taptunadjust.sh |
    sed 's/<CONF>/'"$SERVER"'/g' >$OPENVPNHOME/openvpn/taptunadjust.sh

#
# Create the Windows zip file
#
cp $OPENVPNHOME/servers/${SERVER}.ovpn $OPENVPNHOME/openvpn
cd $OPENVPNHOME/openvpn && zip -9r $OPENVPNHOME/servers/installscripts/openvpn-${SERVER}.zip *
rm $OPENVPNHOME/openvpn/${SERVER}.ovpn


#####################################
#
# Following is all for Linux, Unix & Mac
#
#####################################

cp $OPENVPNHOME/servers/${SERVER}.conf $OPENVPNHOME/openvpn
cd $OPENVPNHOME && tar cz openvpn | uuencode openvpn.taz >$OPENVPNHOME/tmp/openvpn.uu
cd $OPENVPNHOME && shar tmp/install.sh tmp/openvpn.uu >$OPENVPNHOME/servers/installscripts/openvpn-${SERVER}.sh

sed -i 's/exit 0/.\/tmp\/install.sh\nexit 0/g' $OPENVPNHOME/servers/installscripts/openvpn-${SERVER}.sh

rm -f $OPENVPNHOME/tmp/install.sh $OPENVPNHOME/tmp/openvpn.uu

rm -f $OPENVPNHOME/servers/${SERVER}.bak $OPENVPNHOME/servers/installscripts/openvpn-${SERVER}.bak


exit
