#####################################################
#  OpenVPN Server Configuration
#####################################################

#local <LOCALIP>

port 1194

proto tcp

dev tapXXX

# Openvpn 2.1 and above: script-security 3 system

ca /etc/openvpn/three/ca.crt
cert /etc/openvpn/three/three.crt
key /etc/openvpn/three/three.key

dh /etc/openvpn/three/dh-three.pem

server 10.12.1.0 255.255.255.0   
#<IFCONFIG-POOL>  <IFCONFIG-POOL-START>  <IFCONFIG-POOL-END> 255.255.255.0

# Allow traffic from one client to other clients on the VPN (probably you don't have this configured!)
# Uncomment this directive to allow different clients to be able to "see" each other.
# By default, clients will only see the server!!!
# client-to-client

up "/etc/openvpn/three/serverup.sh three"
down "/etc/openvpn/three/serverdown.sh three"
down-pre

ifconfig-pool-persist /etc/openvpn/three/ipp.txt
ifconfig-pool-linear
# Openvpn 2.1 and above: topology p2p
# duplicate-cn

#  Ping every 10 seconds, assume remote is down afte 120 seconds
keepalive 10 120

tls-server
tls-auth /etc/openvpn/three/ta.key 0

cipher AES-128-CBC

comp-lzo

max-clients 300

user root
group root

persist-key
persist-tun

status-version 2
status /etc/openvpn/logs/openvpn-three-status.log

log /etc/openvpn/logs/openvpn-three.log

crl-verify /etc/openvpn/three/crl.pem

verb 1

mute 20

# Following added for remote management

# management  
#management-query-passwords yes

# Advanced options








# push "route <ROUTETO> 255.255.255.0"
