#####################################################
#  OpenVPN Server Configuration
#####################################################

#local <LOCALIP>

port 1194

proto udp

dev tapXXX

# Openvpn 2.1 and above: script-security 3 system

ca /etc/openvpn/two/ca.crt
cert /etc/openvpn/two/two.crt
key /etc/openvpn/two/two.key

dh /etc/openvpn/two/dh-two.pem

server 10.11.10.0 255.255.255.0   
#<IFCONFIG-POOL>  <IFCONFIG-POOL-START>  <IFCONFIG-POOL-END> 255.255.255.0

# Allow traffic from one client to other clients on the VPN (probably you don't have this configured!)
# Uncomment this directive to allow different clients to be able to "see" each other.
# By default, clients will only see the server!!!
# client-to-client

up "/etc/openvpn/two/serverup.sh two"
down "/etc/openvpn/two/serverdown.sh two"
down-pre

ifconfig-pool-persist /etc/openvpn/two/ipp.txt
ifconfig-pool-linear
# Openvpn 2.1 and above: topology p2p
# duplicate-cn

#  Ping every 10 seconds, assume remote is down afte 120 seconds
keepalive 10 120

tls-server
tls-auth /etc/openvpn/two/ta.key 0

cipher AES-128-CBC

comp-lzo

max-clients 300

user root
group root

persist-key
persist-tun

status-version 2
status /etc/openvpn/logs/openvpn-two-status.log

log /etc/openvpn/logs/openvpn-two.log

crl-verify /etc/openvpn/two/crl.pem

verb 1

mute 20

# Following added for remote management

# management  
#management-query-passwords yes

# Advanced options








# push "route <ROUTETO> 255.255.255.0"
