<?php 
//
// OpenVPN Management Console
//
// Written by Jonathan B Bayer
//
// Original system written by Brian Tilma and Victor Ocasio
//

require "opencrypt/ajax_tree.php";
$OPENVPNHOME="/home/openvpn";
$OPENVPNSTATUS="/openvpn/status";

session_start();  
//$path=$_SERVER["DOCUMENT_ROOT"]; 
include"inc/config.php";
if($_GET[action]=="loading"){
  echo '<img src="images/loading.gif" />';
  exit;
}


// Following functions are from php.net
// used to read and write ini files.
function read_ini_file($f, &$r, $preserve_quotes=false)
{
  $null = "";
  $r=$null;
  $first_char = "";
  $sec=$null;
  $comment_chars=";#";
  $num_comments = "0";
  $num_newline = "0";

  //Read to end of file with the newlines still attached into $f
  $f = @file($f);
  if ($f === false) {
    return -2;
  }
  // Process all lines from 0 to count($f)
  for ($i=0; $i<@count($f); $i++)
  {
    $w=@trim($f[$i]);
    $first_char = @substr($w,0,1);
    if ($w)
    {
      if ((@substr($w,0,1)=="[") and (@substr($w,-1,1))=="]") {
        $sec=@substr($w,1,@strlen($w)-2);
        $num_comments = 0;
        $num_newline = 0;
      }
      else if ((stristr($comment_chars, $first_char) == true)) {
        $r[$sec]["Comment_".$num_comments]=$w;
        $num_comments = $num_comments +1;
      }         
      else {
        // Look for the = char to allow us to split the section into key and value
        $w=@explode("=",$w);
        $k=@trim($w[0]);
        unset($w[0]);
        $v=@trim(@implode("=",$w));
        // look for the new lines
        if (!$preserve_quotes)
        {
          if ((@substr($v,0,1)=="\"") and (@substr($v,-1,1)=="\"")) {
            $v=@substr($v,1,@strlen($v)-2);
          }
        }

        $r[$sec][$k]=$v;
       
      }
    }
    else {
      $r[$sec]["Newline_".$num_newline]=$w;
      $num_newline = $num_newline +1;
    }
  }
  return 1;
}
function print_nice($elem,$max_level=10,$print_nice_stack=array()){
    if(is_array($elem) || is_object($elem)){
        if(in_array(&$elem,$print_nice_stack,true)){
            echo "<font color=red>RECURSION</font>";
            return;
        }
        $print_nice_stack[]=&$elem;
        if($max_level<1){
            echo "<font color=red>nivel maximo alcanzado</font>";
            return;
        }
        $max_level--;
        echo "<table border=1 cellspacing=0 cellpadding=3 width=100%>";
        if(is_array($elem)){
            echo '<tr><td colspan=2 style="background-color:#333333;"><strong><font color=white>ARRAY</font></strong></td></tr>';
        }else{
            echo '<tr><td colspan=2 style="background-color:#333333;"><strong>';
            echo '<font color=white>OBJECT Type: '.get_class($elem).'</font></strong></td></tr>';
        }
        $color=0;
        foreach($elem as $k => $v){
            if($max_level%2){
                $rgb=($color++%2)?"#888888":"#BBBBBB";
            }else{
                $rgb=($color++%2)?"#8888BB":"#BBBBFF";
            }
            echo '<tr><td valign="top" style="width:40px;background-color:'.$rgb.';">';
            echo '<strong>'.$k."</strong></td><td>";
            print_nice($v,$max_level,$print_nice_stack);
            echo "</td></tr>";
        }
        echo "</table>";
        return;
    }
    if($elem === null){
        echo "<font color=green>NULL</font>";
    }elseif($elem === 0){
        echo "0";
    }elseif($elem === true){
        echo "<font color=green>TRUE</font>";
    }elseif($elem === false){
        echo "<font color=green>FALSE</font>";
    }elseif($elem === ""){
        echo "<font color=green>EMPTY STRING</font>";
    }else{
        echo str_replace("\n","<strong><font color=red>*</font></strong><br>\n",$elem);
    }
} 

function write_ini_file($path, $assoc_arr, $spaces=" ") {
  $content = "";

  foreach ($assoc_arr as $key=>$elem) {
    if (is_array($elem)) {
      if ($key != '') {
        $content .= "[".$key."]\r\n";       
      }
         
      foreach ($elem as $key2=>$elem2) {
        if (beginsWith($key2,'Comment_') == 1 || beginsWith($elem2,';')) {
          $content .= $elem2."\r\n";
        }
        else if (beginsWith($key2,'Newline_') == 1 && ($elem2 == '')) {
          $content .= $elem2."\r\n";
        }
        else {
          $content .= $key2.$spaces."=".$spaces.$elem2."\r\n";
        }
      }
    }
    else {
      $content .= $key.$spaces."=".$spaces.$elem."\r\n";
    }
  }

  if (!$handle = fopen($path, 'w')) {
    return -2;
  }
  if (!fwrite($handle, $content)) {
    return -2;
  }
  fclose($handle);
  return 1;
}

function beginsWith( $str, $sub ) {
  return ( substr( $str, 0, strlen( $sub ) ) == $sub );
}



// =================================

if($_GET[action]=="advancedClient"){
  $c=$_GET[server];
  
  
  read_ini_file("$OPENVPNHOME/scripts/config/vars", $vars);
  
  $username = $vars["PROXY"]["USERNAME"];
  $password = $vars["PROXY"]["PASSWORD"];
  
  $authenticationmethod = $vars["PROXY"]["AUTHENTICATION_METHOD"];
  
  $httpproxyhost = $vars["PROXY"]["HTTP_PROXY_HOST"];
  $httpproxyretry = $vars["PROXY"]["HTTP_PROXY_RETRY"];
  $httpproxytimeout = $vars["PROXY"]["HTTP_PROXY_TIMEOUT"];
  $httpproxyoption_version = $vars["PROXY"]["HTTP_PROXY_OPTION-VERSION"];
  $httpproxyoption_agent = $vars["PROXY"]["HTTP_PROXY_OPTION-AGENT"];
  
  $socksproxyhost = $vars["PROXY"]["SOCKS_PROXY_HOST"];
  $socksproxyretry = $vars["PROXY"]["SOCKS_PROXY_RETRY"];
  
  echo "<BR><strong>Advanced Options for Client: $c</strong><BR>";
  echo "<input type=HIDDEN name=\"servername\" id=\"servername\" type=\"text\" value=\"$c\" >";
  ?>
  <div> 
  <HR><BR><strong>Proxy Options for Client: <? echo $c; ?></strong><BR>
  <table>
      <tr><td>Username: </td><td>
        <input name="username" "id="username" type="text" value="<? echo $username ?>" />
      </td></tr>
      <tr><td>Password: </td><td>
        <input name="password" "id="password" type="text" value="<? echo $password ?>" />
      </td></tr>
      <tr><td>Authentication Method: </td><td>
        <select name="authenticationmethod" id="authenticationmethod">
          <?
            $none=$basic=$ntlm=$auto="";
            if ($vars["PROXY"]["AUTHENTICATION_METHOD"] == "auto") $auto ="selected=\"selected\"";
            if ($vars["PROXY"]["AUTHENTICATION_METHOD"] == "none") $none ="selected=\"selected\"";
            if ($vars["PROXY"]["AUTHENTICATION_METHOD"] == "basic") $basic ="selected=\"selected\"";
            if ($vars["PROXY"]["AUTHENTICATION_METHOD"] == "ntlm") $ntlm ="selected=\"selected\"";
          ?>
          <option value="auto" <? echo $auto; ?> >Auto</option>
          <option value="none" <? echo $none; ?> >None</option>
          <option value="basic" <? echo $basic; ?> >Basic</option>
          <option value="ntlm" <? echo $ntlm ?> >NTLM</option>
        </select>
      </td></tr>
    
      <tr><td>HTTP Proxy Host: </td><td>
        <input name="httpproxyhost" "id="httpproxyhost" type="text" value="<? echo $httpproxyhost ?>" />
      </td></tr>
      <tr><td>HTTP Proxy Retry: </td><td>
        <select name="httpproxyretry" id="httpproxyretry">
          <?
            $yes=$no=$maybe="";
            if ($vars["PROXY"]["HTTP_PROXY_RETRY"] == "yes") $yes ="selected=\"selected\"";
            if ($vars["PROXY"]["HTTP_PROXY_RETRY"] == "no") $no ="selected=\"selected\"";
          ?>
          <option value="no" <? echo $no; ?> >No</option>
          <option value="yes" <? echo $yes ?> >Yes</option>
        </select>
      </td></tr>
      <tr><td>HTTP Proxy Timeout: </td><td>
        <input name="httpproxytimeout" "id="httpproxytimeout" type="text" value="<? echo $httpproxytimeout ?>" />
      </td></tr>
      <tr><td>HTTP Proxy Option-Version: </td><td>
        <input name="httpproxyoption_version" "id="httpproxyoption_version" type="text" value="<? echo $httpproxyoption_version ?>" />
      </td></tr>
      <tr><td>HTTP Proxy Option-Agent: </td><td>
        <input name="httpproxyoption_agent" "id="httpproxyoption_agent" type="text" value="<? echo $httpproxyoption_agent ?>" />
      </td></tr>

  </table>
  
  <input name="gen" type="button" value="Generate Advanced" onClick="gennew(2);"/>
  </div>
  
  <input type=HIDDEN name="newlocflag" id="newlocflag" value="1">
  <div id="gennew"></div>
  <?php 
  exit;  
}

// =================================

if($_GET[action]=="advancedServer"){
  $c=$_GET[server];
  
  read_ini_file("$OPENVPNHOME/scripts/config/vars", $vars);
  
  $fastio = $vars["ADVANCED"]["FAST-IO"];
  $multihome = $vars["ADVANCED"]["MULTIHOME"];
  $mtudisc = $vars["ADVANCED"]["MTU-DISCOVERY"];
  $mtutest = $vars["ADVANCED"]["MTU-TEST"];
  $mssfix = $vars["ADVANCED"]["MSSFIX"];
  $fragment = $vars["ADVANCED"]["FRAGMENT"];
  $verb = $vars["ADVANCED"]["VERB"];
  
  echo "<BR><strong>Advanced Options for Server: $c</strong><BR>";
  echo "<input type=HIDDEN name=\"servername\" id=\"servername\" type=\"text\" value=\"$c\" >";
  ?>
  <div> 
    <table>
      <tr><td>Fast IO: </td><td>
          <select name="fastio" id="fastio">
            <?
              $yes=$no="";
              if ($vars["ADVANCED"]["FAST-IO"] == "yes") $yes ="selected=\"selected\"";
              if ($vars["ADVANCED"]["FAST-IO"] == "no") $no="selected=\"selected\"";
            ?>
            <option value="no" <? echo $no; ?> >No</option>
            <option value="yes" <? echo $yes ?> >Yes</option>
          </select>
      </td></tr>
      <tr><td>Multi-home: </td><td>
        <select name="multihome" id="multihome">
          <?
            $yes=$no=$maybe="";
            if ($vars["ADVANCED"]["MULTIHOME"] == "yes") $yes ="selected=\"selected\"";
            if ($vars["ADVANCED"]["MULTIHOME"] == "no") $no="selected=\"selected\"";
          ?>
          <option value="no" <? echo $no; ?> >No</option>
          <option value="maybe" <? echo $maybe; ?> >Maybe</option>
          <option value="yes" <? echo $yes ?> >Yes</option>
        </select>
      </td></tr>
      <tr><td>MTU-Discovery: </td><td>
        <select name="mtudisc" id="mtudisc">
          <?
            $yes=$no=$maybe=$kernel="";
            if ($vars["ADVANCED"]["MTU-DISCOVERY"] == "kernel") $kernel ="selected=\"selected\"";
            if ($vars["ADVANCED"]["MTU-DISCOVERY"] == "yes") $yes ="selected=\"selected\"";
            if ($vars["ADVANCED"]["MTU-DISCOVERY"] == "maybe") $maybe="selected=\"selected\"";
            if ($vars["ADVANCED"]["MTU-DISCOVERY"] == "no") $no="selected=\"selected\"";
          ?>
          <option value="kernel" <? echo $kernel; ?> >Kernel default</option>
          <option value="no" <? echo $no; ?> >No</option>
          <option value="maybe" <? echo $maybe; ?> >Maybe</option>
          <option value="yes" <? echo $yes ?> >Yes</option>
        </select>
      </td></tr>
      <tr><td>MTU-Test (can take up to 3 minutes to complete): </td><td>
        <select name="mtutest" id="mtutest">
          <?
            $yes=$no=$maybe="";
            if ($vars["ADVANCED"]["MTU-TEST"] == "yes") $yes ="selected=\"selected\"";
            if ($vars["ADVANCED"]["MTU-TEST"] == "no") $no="selected=\"selected\"";
          ?>
          <option value="no" <? echo $no; ?> >No</option>
          <option value="yes" <? echo $yes ?> >Yes</option>
        </select>
      </td></tr>
      <tr><td>MSSFIX: </td><td>
        <? if ($mssfix == "no") $mssfix = ""; ?>
        <input name="mssfix" "id="mssfix" type="text" value="<? echo $mssfix ?>" />
      </td></tr>
      <tr><td>Fragment: </td><td>
        <? if ($fragment == "no") $fragment = ""; ?>
        <input name="fragment" "id="fragment" type="text" value="<? echo $fragment ?>" />
      </td></tr>
      <tr><td>Verbose: </td><td>
          <select name="verb" id="verb">
            <?
              for ($i = 0; $i <= 11; $i++)
              {
                if ($verb == $i) $selected="selected"; else $selected = "";
                echo "<option value=\"$i\" $selected >$i</option>";
              }
            ?>
            </select>
      </td></tr>
  </table>
  
  <input name="gen" type="button" value="Generate Advanced" onClick="gennew(2);"/>
  </div>
  
  <input type=HIDDEN name="newlocflag" id="newlocflag" value="1">
  <div id="gennew"></div>
  <?php 
  exit;  
}

// =================================

if($_GET[action]=="saveVPNinfo"){
  $c=$_GET[server];
  $dns=$_GET[serverdns];
  $port=$_GET[port];
  read_ini_file("$OPENVPNHOME/easy-rsa/keys/$c/vars", $vars, true);
  $vars[""]["PORT"] = '"' . $port . '"';
  $vars[""]["DNS_ADDRESS"] = '"' . $dns . '"';  
  write_ini_file("$OPENVPNHOME/easy-rsa/keys/$c/vars", $vars, "");
  exit;
//  print_nice($vars);
}

// =================================

  if($_GET[action]=="updateVPNinfo"){
  $c=$_GET[server];
//  read_ini_file("$OPENVPNHOME/easy-rsa/keys/$c/vars", $ar, true);
  
  exec("egrep  'PORT|DNS_ADDRESS' $OPENVPNHOME/easy-rsa/keys/$c/vars",$thelist);
  foreach ($thelist as $l => $lv) {
    $tok=strtok($lv, "\"");
    $value=strtok("\"");
    if ( $tok == "PORT=") $port=$value;
    if ( $tok == "DNS_ADDRESS=" ) $dnsaddress=$value;
  }
//print_nice($ar);
//exit;
  echo "<strong>Update VPN Access Info: $c</strong><BR><HR>";
  echo "<input type=HIDDEN name=\"servername\" id=\"servername\" type=\"text\" value=\"$c\" >";
  ?>
  <div> 
    <table>
      <tr><td>Enter Server DNS: </td><td><input name="serverdns" id="serverdns" type="text" value="<? echo $dnsaddress ?>" /> </td></tr>
      <tr><td>Enter Port: </td><td><input name="port" "id="port" type="text" value="<? echo $port ?>" /></td></tr>
    </table>

    <input name="gen" type="button" value="Save" onClick="saveVPNinfo();"/>
  </div>
  
  <input type=HIDDEN name="newlocflag" id="newlocflag" value="1">
  <div id="gennew"></div>
  <?php 
//    write_ini_file("/tmp/vars", $ar, "");
    exit;  
}

// =================================

if($_GET[action]=="newloc"){
  $c=$_GET[server];
  exec("egrep  'PORT|DNS_ADDRESS' $OPENVPNHOME/easy-rsa/keys/$c/vars",$thelist);
  foreach ($thelist as $l => $lv) {
    $tok=strtok($lv, "\"");
    $value=strtok("\"");
    if ( $tok == "PORT=") $port=$value;
    if ( $tok == "DNS_ADDRESS=" ) $dnsaddress=$value;
  }
  echo "<strong>Creating New OpenVPN Location for Server: $c</strong><BR><HR>";
  echo "<input type=HIDDEN name=\"servername\" id=\"servername\" type=\"text\" value=\"$c\" >";
  ?>
  <div> 
    <table>
      <tr><td>Enter Location Name: </td><td><input name="clientloc" id="clientloc" type="text" /> </td></tr>
      <tr><td>Enter Server DNS: </td><td><input name="serverdns" id="serverdns" type="text" value="<? echo $dnsaddress ?>" /> </td></tr>
      <tr><td>Enter Port: </td><td><input name="port" "id="port" type="text" value="<? echo $port ?>" /></td></tr>
    </table>

    <input name="gen" type="button" value="GENERATE" onClick="gennew(0);"/>
    &nbsp;<input name="adv" type="button" value="Advanced Options" onClick="gennew(1);" tabindex="18"/>
  </div>
  
  <input type=HIDDEN name="newlocflag" id="newlocflag" value="1">
  <div id="gennew"></div>
  <?php 
  exit;  
}

// =================================

if($_GET[action]=="install"){
  $c=$_GET[server];
  $dir = sys_get_temp_dir() . "/ovpninstall";
  if (!@mkdir($dir))
  {
    echo "Unable to make install directory: $dir, exiting";
    exit;
  }
  
  $f = "openvpn-$_GET[server].sh";
  if (!copy("$OPENVPNHOME/servers/installscripts/$f", "$dir/$f"))
  {
    echo "Unable to copy install file: $f, exiting";
    exit;
  }
  if (!chdir($dir))
  {
    echo "Unable to change to directory: $dir, exiting";
    exit;
  }
  if (!chmod("$dir/$f", 0755))
  {
    echo "Unable to change permissions of file: $dir/$f, exiting";
    exit;
  }

  exec("sudo $OPENVPNHOME/scripts/install-local.sh $dir/$f",$thelist, $rc);
  foreach($thelist as $l =>$lv) {
    echo "$lv<BR>";
  }
  
  $thelist="";
  exec("sudo $OPENVPNHOME/scripts/install-local.sh $dir/install.sh", $thelist);
  foreach($thelist as $l =>$lv) {
    echo "$lv<BR>";
  }
  @unlink("$dir/install.sh");
  @unlink("$dir/$f");
  @rmdir($dir);

  exit;
}

// =================================

if($_GET[action]=="uninstall"){
  $c=$_GET[server];
  echo "Uninstalling $c.conf<BR>";
  $files = array("$c.conf",
                 "$c/ca.key",
                 "$c/ca.crt",
                 "$c/ta.key",
                 "$c/$c.crt",
                 "$c/$c.key",
                 "$c/ipp.txt",
                 "$c/crl.pem",
                 "$c/dh-ws123.pem",
                 "$c/serverup.sh",
                 "gateway/$c");
  foreach($files as $f)
  {
    echo "$f<BR>";
    exec("sudo $OPENVPNHOME/scripts/install-local.sh /bin/rm -f /etc/openvpn/$f", $thelist);
    foreach($thelist as $l =>$lv) {
      echo "$lv<BR>";
    }
  }
  echo "/etc/openvpn/$c/<BR>";
  exec("sudo $OPENVPNHOME/scripts/install-local.sh /bin/rmdir /etc/openvpn/$c", $thelist);
  foreach($thelist as $l =>$lv) {
    echo "$lv<BR>";
    }
  
  exec("sudo $OPENVPNHOME/scripts/install-local.sh /etc/init.d/openvpn restart", $thelist);
  foreach($thelist as $l =>$lv) {
    echo "$lv<BR>";
  }

  exit;
}

// =================================

if($_GET[action]=="revoke"){
  $c=$_GET[server];
  exec("$OPENVPNHOME/scripts/revoke_client.sh $_GET[server] ",$thelist);
  foreach($thelist as $l =>$lv) {
//    echo "<div>$lv</div>";
  }
  if (substr($lv, 0, 8) == "error 23")
  {
    echo "CRL file created, now you need to install it";
    }
  exit;
}

// =================================

if($_GET[action]=="installRevoke"){
  $c=$_GET[server];
  $dir = sys_get_temp_dir() . "/ovpninstall";
  if (!@mkdir($dir))
  {
    echo "Unable to make install directory: $dir, exiting<BR>";
//    exit;
  }
  $f = "openvpn-$_GET[server].sh";
  $d="-";
  $dash=strpos($c, $d, 0);
  if ($dash) {
    $SERVER=substr($c, 0, $dash);
    $LOC = substr($c, $dash + 1);
  }
  else
  {
    echo "Invalid action, exiting<BR>";
    exit;
  }
  $lv="$OPENVPNHOME/easy-rsa/keys/$SERVER/$c-crl.pem";
  
  $file = fopen($dir . "/" . $f, "w");
  
  fprintf($file, "#! /bin/bash\n");
  fprintf($file, "cat $lv >>//etc/openvpn/crl.pem\n");
  fclose($file);
  if (!chmod("$dir/$f", 0755))
  {
    echo "Unable to change permissions of file: $dir/$f, exiting";
    exit;
  }

  $thelist="";
  exec("sudo $OPENVPNHOME/scripts/install-local.sh $dir/$f", $thelist);
  foreach($thelist as $l =>$lv) {
    echo "$lv<BR>";
  }
  @unlink("$dir/$f");
  @rmdir($dir);

  exit;

}

// =================================

if($_GET[action]=="remove"){
  $c=$_GET[server];
  $d="-";
  $dash=strpos($c, $d, 0);
  if ($dash) {
    $SERVER=substr($c, 0, $dash);
    $LOC = substr($c, $dash + 1);
  }
  else $SERVER=$c;
  
  exec("ls -1 $OPENVPNHOME/easy-rsa/keys/$SERVER/$c*",$thelist);
  
  foreach($thelist as $l =>$lv) {
    $n++;
#    echo "<div>REMOVING: $lv</div>";
    exec("rm -rf $lv");
  }
  if (!$dash)
  {
    exec("rm -fr $OPENVPNHOME/servers/$c.conf");
    exec("rm -fr $OPENVPNHOME/servers/$c.ovpn");
    exec("rm -fr $OPENVPNHOME/servers/$c-*.conf");
    exec("rm -fr $OPENVPNHOME/servers/$c-*.ovpn");
    exec("rm -fr $OPENVPNHOME/servers/installscripts/openvpn-$c.sh");
    exec("rm -fr $OPENVPNHOME/servers/installscripts/openvpn-$c.zip");
    exec("rm -fr $OPENVPNHOME/easy-rsa/keys/$c");
  }
  
  // Always delete the clients, this way when a server is deleted
  // all the clients for that server will also be deleted
  
  exec("rm -fr $OPENVPNHOME/clients/$ci-*conf");
  exec("rm -fr $OPENVPNHOME/clients/$c-*.ovpn");
  exec("rm -fr $OPENVPNHOME/clients/installscripts/openvpn-$c.sh");
  exec("rm -fr $OPENVPNHOME/clients/installscripts/openvpn-$c-*.sh");
  exec("rm -fr $OPENVPNHOME/clients/installscripts/openvpn-$c.zip");
  exec("rm -fr $OPENVPNHOME/clients/installscripts/openvpn-$c-*.zip");
 
  exit;
}

// =================================

if($_GET[action]=="gennew"){
  $name=$_GET[server] . "-" . $_GET[clientloc];
  
  $serverdns = "$_GET[serverdns]";
  $port = "$_GET[port]";
  
  $username = "$_GET[username]";
  $password = "$_GET[password]";
  $authenticationmethod = "$_GET[authenticationmethod]";
  $httpproxyhost = "$_GET[httpproxyhost]";
  $httpproxyretry = "$_GET[httpproxyretry]";
  $httpproxytimeout = "$_GET[httpproxytimeout]";
  $httpproxyoption_version = "$_GET[httpproxyoption_version]";
  $httpproxyoption_agent = "$_GET[httpproxyoption_agent]";
  
  read_ini_file("$OPENVPNHOME/scripts/config/vars", $vars);
  if (!$username)
  {
    echo "reading defaults<BR>";
    
    $username = $vars["PROXY"]["USERNAME"];
    $password = $vars["PROXY"]["PASSWORD"];
    
    $authenticationmethod = $vars["PROXY"]["AUTHENTICATION_METHOD"];
    
    $httpproxyhost = $vars["PROXY"]["HTTP_PROXY_HOST"];
    $httpproxyretry = $vars["PROXY"]["HTTP_PROXY_RETRY"];
    $httpproxytimeout = $vars["PROXY"]["HTTP_PROXY_TIMEOUT"];
    $httpproxyoption_version = $vars["PROXY"]["HTTP_PROXY_OPTION-VERSION"];
    $httpproxyoption_agent = $vars["PROXY"]["HTTP_PROXY_OPTION-AGENT"];
    
    $socksproxyhost = $vars["PROXY"]["SOCKS_PROXY_HOST"];
    $socksproxyretry = $vars["PROXY"]["SOCKS_PROXY_RETRY"];
  }
  $verb = $vars["ADVANCED"]["VERB"];

  $files=array("$name.crt"=>"$OPENVPNHOME/easy-rsa/keys/$server/$name.crt");

  
  foreach($files as $s=>$sv){ 	
    if (file_exists($sv)) {
      echo "<div  style=\"background-color:#99FF99; color:#FFFFFF;\"><a href=\"/keys/$s\" target=_blank><img src=\"images/icons/application_put.png\" border=0/></a> The file $s exists</div>";
    } else {
      exec("$OPENVPNHOME/scripts/make_install_client.sh $_GET[server] $_GET[clientloc] $serverdns $port \"$username\" \"$password\" $authenticationmethod \"$httpproxyhost\" $httpproxyretry $httpproxytimeout \"$httpproxyoption_version\" \"$httpproxyoption_agent\" $verb",$thelist);
      
      foreach($thelist as $l =>$lv) {
        echo "<div>$lv </div>";
      }		
      //			echo "<div  style=\"background-color:#FF0000; color:#FFFFFF;\">!!!The file $s does not exist</div>";
    }
  }
  
  exit;
}

// =================================

if($_GET[action]=="gennewserver"){
  $name = "$_GET[server]";
  $country = "$_GET[country]";
  $province = "$_GET[province]";
  $city = "$_GET[city]";
  $email = "$_GET[email]";
  $network = "$_GET[network]";
  $netmask = "$_GET[netmask]";
  $dnsaddress = "$_GET[dnsaddress]";
  $port = "$_GET[port]";
  $protocol = "$_GET[protocol]";
  $tuntap = "$_GET[tuntap]";
  $dhbits = "$_GET[dhbits]";
  $client2client = "$_GET[client2client]";
  $routeto = "$_GET[routeto]";
  $clientaccess = "$_GET[clientaccess]";
  $duplicatecn = "$_GET[duplicatecn]";
  $bridge = "$_GET[bridge]";
  $windows = "$_GET[windows]";
  $poolstart = "$_GET[poolstart]";
  $poolend = "$_GET[poolend]";
  
  $fastio = "$_GET[fastio]";
  $multihome = "$_GET[multihome]";
  $mtudisc = "$_GET[mtudisc]";
  $mtutest = "$_GET[mtutest]";
  $mssfix = "$_GET[mssfix]";
  $fragment = "$_GET[fragment]";
  $verb = "$_GET[verb]";
    
  if (!$fastio)
  {
    echo "reading defaults<BR>";
    read_ini_file("$OPENVPNHOME/scripts/config/vars", $vars);
  
    $fastio = $vars["ADVANCED"]["FAST-IO"];
    $multihome = $vars["ADVANCED"]["MULTIHOME"];
    $mtudisc = $vars["ADVANCED"]["MTU-DISCOVERY"];
    $mtutest = $vars["ADVANCED"]["MTU-TEST"];
    $mssfix = $vars["ADVANCED"]["MSSFIX"];
    $fragment = $vars["ADVANCED"]["FRAGMENT"];
    $verb = $vars["ADVANCED"]["VERB"];
  }
  
  if ($routeto == "") $routeto="none";
  
  $files=array("$name.crt"=>"$OPENVPNHOME/easy-rsa/keys/$name/$name.crt");
  
  foreach($files as $s=>$sv){ 	
    if (file_exists($sv)) {
      echo "<div  style=\"background-color:#99FF99; color:#FFFFFF;\"><a href=\"/keys/$s\" target=_blank><img src=\"/images/icons/application_put.png\" border=0/></a> The file $s exists</div>";
    } else {
      exec("$OPENVPNHOME/scripts/make_install_server.sh $name \"$country\" \"$province\" \"$city\" $name $name $email $network $netmask $port $dnsaddress $protocol $tuntap $dhbits $client2client $clientaccess $duplicatecn $routeto $bridge $windows \"$poolstart\" \"$poolend\" $fastio $multihome $mtudisc $mtutest \"$mssfix\" \"$fragment\" $verb",$thelist);
      
      foreach($thelist as $l =>$lv) {
        echo "<div>$lv </div>";
      }		
      //			echo "<div  style=\"background-color:#FF0000; color:#FFFFFF;\">!!!The file $s does not exist</div>";
      echo "updating ini file<BR>";
      read_ini_file("$OPENVPNHOME/scripts/config/vars", $vars);
      $vars["PORT"]["PORT"] = $vars["PORT"]["PORT"] + $vars["PORT"]["PORT_INCREMENT"];
      write_ini_file("$OPENVPNHOME/scripts/config/vars", $vars);
    }
  }
  
  exit;
}
      

// =================================

if($_GET[action]=="makenew"){ 
  echo "<strong>Creating New OpenVPN Server</strong><BR><HR>";
  
  read_ini_file("$OPENVPNHOME/scripts/config/vars", $vars);
  $port = $vars["PORT"]["PORT"];
?>
<strong>Server & Network Information</strong><BR><BR>
<div> 
  <table>
    <tr><td>Enter server name (no spaces): </td><td><input name="servername" id="servername" type="text" tabindex="1"/> </td>
        <td>&nbsp;</td><td>&nbsp</td><td>DNS Address: </td><td><input name="dnsaddress" "id="dnsaddress" type="text" tabindex="6"/></td>
    </tr>
    <tr><td>Country: </td><td><input name="country" id="country" type="text" maxlength="2" size="2" tabindex="2"/></td>
       <td>&nbsp;</td><td>&nbsp</td><td>VPN Net/Gw: </td><td><input name="network" "id="network" type="text" tabindex="7"/> (gateway when bridging)</td>
    </tr>
    <tr><td>Province/State: </td><td><input name="province" id="province" type="text" maxlength="2" size="2" tabindex="3"/></td>
          <td>&nbsp;</td><td>&nbsp</td><td>VPN Netmask: </td><td><input name="netmask" "id="netmask" type="text" value="255.255.255.0" tabindex="8"/></td></tr>

        <tr><td>City: </td><td><input name="city" id="city" type="text" tabindex="4"/></td>
              <td>&nbsp;</td><td>&nbsp</td><td>Port: </td><td><input name="port" "id="port" type="text" value="<? echo $port; ?>" tabindex="9" /></td></tr>

            <td>Email: </td><td?<input name="email" "id="email" type="text" tabindex="5"/></td>
             <td></td><td></td><td>Ifconfig pool:</td><td>
               <input name="poolstart" "id="poolstart" type="text" value="" tabindex="8"/>
               -
               <input name="poolend" "id="poolend" type="text" value="" tabindex="8"/></td>
               
               
             </tr>
  </table>
  <hr>
  <strong>OpenVPN Options</strong><br><br>
  <table>
    <tr><td>Protocol: </td><td><select name="protocol" id="protocol" tabindex="10">
          <?
            $tcp=$udp="";
            if ($vars["OPTIONS"]["PROTOCOL"] == "tcp") $tcp="selected=\"selected\"";
            if ($vars["OPTIONS"]["PROTOCOL"] == "udp") $udp="selected=\"selected\"";
          ?>
          <option value="tcp" <? echo $tcp; ?> >TCP</option>
          <option value="udp" <? echo $udp; ?> >UDP</option>
    </select></td></tr>
    <tr><td>  Tun/Tap: </td><td><select name="tuntap" id="tuntap" tabindex="11">
          <? 
            $tt=array("tapXXX", "tunXXX", "tap", "tun");
            $dd=array("Tap - static", "Tun - static", "Tap", "Tun");
            $n = 0;
            foreach($tt as $l =>$lv) 
            {
              echo "<option value=\"$lv\"";
              if ($lv == $vars["OPTIONS"]["TAPTUN"]) echo "selected=\"selected\"";
              echo ">$dd[$n]</option>";
              $n++;
            }
          ?>
    </select></td>
             <td>&nbsp;</td><td>Ethernet Bridging: </td><td><select name="bridge" id="bridge" tabindex="11">
          <?
            $yes=$no="";
            if ($vars["OPTIONS"]["BRIDGE"] == "yes-proxy") $yesProxy="selected=\"selected\"";
            if ($vars["OPTIONS"]["BRIDGE"] == "yes-nogw") $yesNogw="selected=\"selected\"";
            if ($vars["OPTIONS"]["BRIDGE"] == "yes") $yes="selected=\"selected\"";
            if ($vars["OPTIONS"]["BRIDGE"] == "no") $no="selected=\"selected\"";
          ?>
          <option value="yesProxy" <? echo $yesProxy; ?> >Yes - DHCP Proxied</option>
          <option value="yesNogw" <? echo $yesNogw; ?> >Yes - DHCP Proxied, no gateway</option>
          <option value="yes" <? echo $yes; ?> >Yes</option>
          <option value="no" <? echo $no; ?> >No</option>
    </select></td></tr>
    <tr><td>DH Bits:</td><td> <select name="dhbits" id="dhbits" tabindex="12">
          <?
            $i1024=$i2048="";
            if ($vars["OPTIONS"]["DHBITS"] == "1024") $i1024="selected=\"selected\"";
            if ($vars["OPTIONS"]["DHBITS"] == "2048") $i2048="selected=\"selected\"";
          ?>
          
          <option value="1024" <? echo $i1024; ?> >1024</option>
          <option value="2048" <? echo $i2048; ?> >2048</option>
    </select></td></tr>
    <tr><td>Will multiple clients be using the same certificates?:</td><td> 
        <select name="duplicatecn" id="duplicatecn" tabindex="13">
          <?
            $yes=$no="";
            if ($vars["OPTIONS"]["DUPLICATECN"] == "yes") $yes="selected=\"selected\"";
            if ($vars["OPTIONS"]["DUPLICATECN"] == "no") $no="selected=\"selected\"";
          ?>
          <option value="no" <? echo $no; ?> >No</option>
          <option value="yes" <? echo $yes ?> >Yes</option>
        </select>
      </td>
    <td></td><td>Will there be any Windows clients?:</td><td> 
        <select name="windows" id="windows" tabindex="13">
          <?
            $yes=$no="";
            if ($vars["OPTIONS"]["WINDOWS"] == "yes") $yes="selected=\"selected\"";
            if ($vars["OPTIONS"]["WINDOWS"] == "no") $no="selected=\"selected\"";
          ?>
          <option value="yo" <? echo $no; ?> >No</option>
          <option value="yes" <? echo $yes ?> >Yes</option>
        </select>
    </td>
    </tr>

  </table><HR>
  <strong>The following options only make sense for a tunnel, and will be ignored if a TAP interface is selected:</strong><BR><BR>
  <table>
    <tr><td>Allow client to access the VPN server:</td><td> <select name="clientaccess" id="clientaccess" tabindex="14">
          <?
            $yes=$no="";
            if ($vars["TUNNEL"]["CLIENTACCESS"] == "yes") $yes="selected=\"selected\"";
            if ($vars["TUNNEL"]["CLIENTACCESS"] == "no") $no="selected=\"selected\"";
          ?>
          <option value="no" <? echo $no; ?> >No</option>
          <option value="yes" <? echo $yes; ?> >Yes</option>
    </select></td></tr>
    <tr><td>Allow client-to-client communication:</td><td> <select name="client2client" id="client2client" tabindex="15">
          <?
            $yes=$no="";
            if ($vars["TUNNEL"]["CLIENT2CLIENT"] == "yes") $yes="selected=\"selected\"";
            if ($vars["TUNNEL"]["CLIENT2CLIENT"] == "no") $no="selected=\"selected\"";
          ?>
          <option value="no" <? echo $no; ?> >No</option>
          <option value="yes" <? echo $yes ?> >Yes</option>
    </select></td></tr>
    <tr><td>Route tunnel to:</td>
          <td><input name="routeto" "id="routeto" type="text" tabindex="16"/>
    </td></tr>
  </table>
  <HR>
<!--  <strong>Network Information</strong><br><br>
  <table>
    <tr><td>DNS Address: </td><td><input name="dnsaddress" "id="dnsaddress" type="text" /></td></tr>
    <tr><td>VPN Network: </td><td><input name="network" "id="network" type="text" /></td></tr>
    <tr><td>VPN Netmask: </td><td><input name="netmask" "id="netmask" type="text" value="255.255.255.0" /></td></tr>
    <tr><td>Port: </td><td><input name="port" "id="port" type="text" value="<? echo $port; ?>" /></td></tr>
  </table> -->
   
  <input name="gen" type="button" value="GENERATE" onClick="gennew(0);" tabindex="17"/>
  &nbsp;<input name="adv" type="button" value="Advanced Options" onClick="gennew(1);" tabindex="18"/>
    
  <input type=HIDDEN name="clientloc" id="clientloc" value="">  
  <input type=HIDDEN name="newlocflag" id="newlocflag" value="">  
</div>
<div id="gennewserver"></div>
  
  <?php 
  exit;
}

// =================================

if($_GET[action]=="clientlocs"){
  echo "<div>one</div><div>two</div>";
  return;
  
  exec("ls $OPENVPNHOME/easy-rsa/keys",$thelist);

  foreach($thelist as $l =>$lv) {
    $n++;
    $lv2=str_replace("$OPENVPNHOME/easy-rsa/keys/","",$lv);
    $lv2=$lv;
    ?>
    <div><?php echo $n ?>. <a href="javascript:ajaxpage('index.php?action=serverinfo&systemid=<?php echo $lv2 ?>','serverinfo');">
      <?php echo $lv2 ?></a></div>
    <?php 
    }
}

// =================================

if($_GET[action]=="clearinfo"){
  return;
}

// =================================



if($_GET[action]=="serverinfo"){  ?>

  <div><strong><?php echo strtoupper($_GET[systemid]); ?></strong></div>
  <?  
    if (file_exists("/etc/openvpn/$_GET[systemid]"))
      echo "<BR><a href=\"$OPENVPNSTATUS?Action=Status&server=$_GET[systemid]\">" . strtoupper($_GET[systemid]) . " Server Status</a>"; 
  ?>

  <br />
  <br />
  
  
  <div><strong>Full Package: </strong>
<?php 
  $clientloc=$_GET[systemid];
  $d="-";
  $dash=strpos($clientloc, $d, 0);
  if ($dash) {
    $SYSTEM=substr($clientloc, 0, $dash);
    $LOC = substr($clientloc, $dash + 1);
    $filefull=array("openvpn-$_GET[systemid].sh"=>"$OPENVPNHOME/clients/installscripts/openvpn-$_GET[systemid].sh",
                    "openvpn-$_GET[systemid].zip"=>"$OPENVPNHOME/clients/installscripts/openvpn-$_GET[systemid].zip");
  }
  else 
  {
    $SYSTEM=$clientloc;
    $filefull=array("openvpn-$_GET[systemid].sh"=>"$OPENVPNHOME/servers/installscripts/openvpn-$_GET[systemid].sh",
                    "openvpn-$_GET[systemid].zip"=>"$OPENVPNHOME/servers/installscripts/openvpn-$_GET[systemid].zip");
  }
  foreach($filefull as $s=>$sv){ 	
    if (file_exists($sv)) {
      if ($dash) echo "<div  style=\"background-color:#99FF99; color:#FFFFFF;\"> <a href=\"/clientInstallScripts/$s\"  target=_blank><img src=\"images/icons/application_put.png\" border=0/>$s</a> </div>";
      else
        echo "<div  style=\"background-color:#99FF99; color:#FFFFFF;\"><a href=\"/serverInstallScripts/$s\"  target=_blank><img src=\"images/icons/application_put.png\" border=0/>$s</a> </div>";
    } else {
      echo "<div  style=\"background-color:#FF0000; color:#FFFFFF;\">!!!$s does not exist</div>";
    } 
  }
?>
  
  </div>
  <br />
  <br />
  <div> <strong>Download Files</strong> </div>
  <?php 
  $files=array(
    "$_GET[systemid].crt"=>"$OPENVPNHOME/easy-rsa/keys/$SYSTEM/$_GET[systemid].crt",
    "$_GET[systemid].key"=>"$OPENVPNHOME/easy-rsa/keys/$SYSTEM/$_GET[systemid].key",
    "ca.crt"=>"$OPENVPNHOME/easy-rsa/keys/$SYSTEM/ca.crt",
    "ta.key"=>"$OPENVPNHOME/easy-rsa/keys/$SYSTEM/ta.key");
  if (!$dash)
  {
    $files["ca.key"]="$OPENVPNHOME/easy-rsa/keys/$SYSTEM/ca.key";
    $files["dh-$SYSTEM.pem"]="$OPENVPNHOME/easy-rsa/keys/$SYSTEM/dh-$SYSTEM.pem";
  }
   
  
  foreach($files as $s=>$sv){           
    if (file_exists($sv)) {
      
      $sv2 = str_replace($OPENVPNHOME, "/openvpnfiles/", $sv);
      echo "<div  style=\"background-color:#99FF99; color:#FFFFFF;\"><a href=\"$sv2\" target=_blank><img src=\"images/icons/application_put.png\" border=0/>$s</a></div>";
    } else {
      echo "<div  style=\"background-color:#FF0000; color:#FFFFFF;\">!!!The file $s does not exist</div>";
    }
  }
  
  $files=array(
               "README.txt"=>"$OPENVPNHOME/servers/README.txt",
               "up.sh"=>"$OPENVPNHOME/scripts/up.sh",
               "down.sh"=>"$OPENVPNHOME/scripts/down.sh");
  if (!$dash) {$files["$_GET[systemid].conf"]="$OPENVPNHOME/servers/$_GET[systemid].conf";}
         else {$files["$_GET[systemid].conf"]="$OPENVPNHOME/clients/$_GET[systemid].conf";}
  if (!$dash) {$files["$_GET[systemid].ovpn"]="$OPENVPNHOME/servers/$_GET[systemid].ovpn";}
         else {$files["$_GET[systemid].ovpn"]="$OPENVPNHOME/clients/$_GET[systemid].ovpn";}
  
  foreach($files as $s=>$sv){           
    if (file_exists($sv)) {
      $sv2 = str_replace("$OPENVPNHOME", "/openvpnfiles", $sv);
      echo "<div  style=\"background-color:#99FF99; color:#FFFFFF;\"><a href=\"$sv2\"  target=_blank>
      <img src=\"images/icons/application_put.png\" border=0/>$s</a></div>";
    } else {
      echo "<div  style=\"background-color:#FF0000; color:#FFFFFF;\">!!!The file $sv does not exist</div>";
    }
  }
  if ($dash)
  {
    $lv="$OPENVPNHOME/easy-rsa/keys/$SYSTEM/$clientloc-crl.pem";
    if (file_exists($lv))
    {
      $REVOKED=true;
      $sv2 = str_replace("$OPENVPNHOME", "", $lv);
      echo "<BR><BR><div> <strong>Certificate Revocation File</strong> </div>";
      echo "<div  style=\"background-color:#99FF99; color:#FFFFFF;\"><a href=\"$sv2\"  target=_blank>
      <img src=\"images/icons/application_put.png\" border=0/>$clientloc-crl.pem</a></div><BR><BR>";
    }
  }


  echo "<div id=\"remove\">";
//  echo "<div id=\"remove\" align=\"left\";";
  echo "<table><tr>";
  if (!$dash)
  {
    echo "<td><input name=\"MAKE NEW\" type=\"button\" value=\"New Location\"onClick=\"ajaxpage('";
    echo $_SERVER['PHP_SELF'];
    echo "?action=newloc&server=$_GET[systemid]','serverinfo');\" /></td>";
    
    echo "<td>&nbsp;<input name=\"MAKE NEW\" type=\"button\" value=\"Update VPN Access Info\"onClick=\"ajaxpage('";
    echo $_SERVER['PHP_SELF'];
    echo "?action=updateVPNinfo&server=$_GET[systemid]','serverinfo');\" /></td>";
    
    if (!file_exists("/etc/openvpn/$_GET[systemid]"))
    {
      echo "<td>&nbsp;</td><td><input name=\"MAKE NEW\" type=\"button\" value=\"Install on this system\"onClick=\"ajaxpage('";
      echo $_SERVER['PHP_SELF'];
      echo "?action=install&server=$_GET[systemid]','serverinfo');\" /></td>";
    }
    else
    {
      echo "<td>&nbsp;</td><td><input name=\"MAKE NEW\" type=\"button\" value=\"Uninstall from this system\"onClick=\"ajaxpage('";
      echo $_SERVER['PHP_SELF'];
      echo "?action=uninstall&server=$_GET[systemid]','serverinfo');\" /></td>";
  
    }
    /*  <!--<input name="MAKE NEW" type="button" value="REGENERATE" /> <input name="MAKE NEW" type="button" value="REVOKE" />-->  */
  } 
  
  
  echo "<td>&nbsp;</td><td><input name=\"removeFiels\" id=\"removeFiels\" type=\"button\" value=\"REMOVE\" onClick=\"removeF('".$_GET[systemid]."');\"></td>";
  if ($dash)
    if (! $REVOKED) 
    {
      echo "<td>&nbsp;</td><TD><input name=\"Revoke\" id=\"Revoke\" type=\"button\" value=\"Revoke\" onClick=\"revokeF('".$_GET[systemid]."');\"></td>";
    }
    else
    {
      echo "<td>&nbsp;</td><TD><input name=\"installRevoke\" id=\"installRevoke\" type=\"button\" value=\"Install revocation certificate on this server\" onClick=\"installRevokeF('".$_GET[systemid]."');\"></td>";
    }
    
  echo "</tr></table>";
  
  
#    onClick=\"ajaxpage('";
#  echo $_SERVER['PHP_SELF'];
#  echo "?action=remove&server=$_GET[systemid]','serverinfo');\" />";
  echo "</div>";
  exit;
}

// =================================


if($_GET[action]=="loadserver"){ 
  $tree_data = array();
  $n=0;
  //echo "".dcon($timenow,35);
  
  exec("ls $OPENVPNHOME/easy-rsa/keys",$thelist);
  
  //echo count($thelist);
  foreach($thelist as $l =>$lv) {
    $lv2=$lv;
    $url = "javascript:ajaxpage('index.php?action=serverinfo&systemid=$lv2','serverinfo');";
    $data=array(name => $lv2, 
                url >= $url,
                parent => "0");
    $data[url] = $url;
    $tree_data[$n++] = $data;
    
    $thelist2="";
    exec("ls $OPENVPNHOME/easy-rsa/keys/$lv2/$lv2-*.crt 2>/dev/null",$thelist2);
    
    if (!$thelist2)
    {
      $data=array(name => "no client locations defined", 
                  url >= "",
                  parent => $lv2);
      $data[url] = $url;
      $tree_data[$n++] = $data;
    } else
    foreach($thelist2 as $l2 =>$lv3) {
      $lv4=str_replace("$OPENVPNHOME/easy-rsa/keys/$lv2/$lv2-","",$lv3);
      $lv4=str_replace(".crt","",$lv4);
      $url = "javascript:ajaxpage('index.php?action=serverinfo&systemid=$lv2-$lv4','serverinfo');";
      $data=array(name => "$lv4", 
                  url >= $url,
                  parent => $lv2);
      $data[url] = $url;
      $tree_data[$n++] = $data;
  
    }
  }
  
  /*
  $ajax_tree_table['0'] = "ffffff";
  $ajax_tree_table['1'] = "eeeeee";
  $ajax_tree_table['2'] = "e5e5e5";
  $ajax_tree_table['3'] = "dddddd";
  $ajax_tree_table['4'] = "d5d5d5";
  $ajax_tree_table['5'] = "cccccc";
  */
  
  $output = ajax_tree($tree_data,0,0,1);
  echo "<div>$output</div>";
  echo "<BR><a href=\"$OPENVPNSTATUS\">All Servers Status</a>";
  exit;
}

// =================================


?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>OpenVPN | Client Setup System</title>
<script language="javascript" src="inc/ajaxroutine.js"> </script>
<script language="javascript" src="inc/system.js"> </script>

<script src="inc/scriptaculous/lib/prototype.js" type="text/javascript"></script>
<script src="inc/scriptaculous/src/scriptaculous.js" type="text/javascript"></script>
<script src="inc/scriptaculous/src/unittest.js" type="text/javascript"></script>

<script language="javascript" src="inc/inplacedatetimeselect.js"> </script>   
<style type="text/css">
<!--
body,td,th {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 13px;
}
body {
	margin-left: 0px;
	margin-top: 0px;
	margin-right: 0px;
	margin-bottom: 0px;
}
-->
</style>


<style type="text/css">

.text					{ font-family : Verdana, Arial, Helvetica, sans-serif; font-size : 13px; color : #000000; }
a.text			{ color: #0000aa; text-decoration: none; }
a.text:hover		{ color: #0000aa; text-decoration: underline; }

.ajax_tree0		{ font-family : Verdana, Arial, Helvetica, sans-serif; font-size : 18px; color: #D21A20; text-decoration: none; }
a.ajax_tree0		{ color: #D21A20; text-decoration: none; }
a.ajax_tree0:hover        { color: #D21A20; text-decoration: underline; }

.ajax_tree1		{ font-family : Verdana, Arial, Helvetica, sans-serif; font-size : 17px; color: #D21A20; text-decoration: none; }
a.ajax_tree1		{ color: #D21A20; text-decoration: none; }
a.ajax_tree1:hover        { color: #D21A20; text-decoration: underline; }

.ajax_tree2		{ font-family : Verdana, Arial, Helvetica, sans-serif; font-size : 16px; color: #D21A20; text-decoration: none; }
a.ajax_tree2		{ color: #D21A20; text-decoration: none; }
a.ajax_tree2:hover        { color: #D21A20; text-decoration: underline; }

.ajax_tree3		{ font-family : Verdana, Arial, Helvetica, sans-serif; font-size : 15px; color: #D21A20; text-decoration: none; }
a.ajax_tree3		{ color: #D21A20; text-decoration: none; }
a.ajax_tree3:hover        { color: #D21A20; text-decoration: underline; }

.ajax_tree4		{ font-family : Verdana, Arial, Helvetica, sans-serif; font-size : 14px; color: #D21A20; text-decoration: none; }
a.ajax_tree4		{ color: #D21A20; text-decoration: none; }
a.ajax_tree4:hover        { color: #D21A20; text-decoration: underline; }

.ajax_tree5		{ font-family : Verdana, Arial, Helvetica, sans-serif; font-size : 13px; color: #D21A20; text-decoration: none; }
a.ajax_tree5		{ color: #D21A20; text-decoration: none; }
a.ajax_tree5:hover        { color: #D21A20; text-decoration: underline; }

</style>

<script type="text/javascript">

var open_obj = new Array()

function Expand(obj,checkbox,swap) 
{
  var obj2 = obj;
  var img_obj = "img_" + obj;
  var div_obj = "div_" + obj;
  var check_obj = "check_" + obj;
      
  if (open_obj[obj] == true) {
    if (checkbox != "1") {
      document.getElementById(div_obj).style.display = "none";
      document.getElementById(img_obj).src = "collapsed.gif";
      open_obj[obj] = false;
    }
  } else 
  {
    var top_options = document.getElementById('tree_top_options').value;
    if (top_options != "") {
      var split_top_options = new Array();
      split_top_options = top_options.split("|");
      for(var i = 0; i < split_top_options.length; i++){
        if (obj2 == split_top_options[i]) {
        } else {
          var objb = split_top_options[i];
          if (objb != "") {
            var img_objb = "img_" + objb;
            var div_objb = "div_" + objb;
            var check_objb = "check_" + objb;
            if (swap == "1") {
              document.getElementById(div_objb).style.display = "none";
              document.getElementById(img_objb).src = "collapsed.gif";
              open_obj[objb] = false;
            }
          }
        }
      }
    }
    document.getElementById(div_obj).style.display = "block";
    document.getElementById(img_obj).src = "expanded.gif";
    open_obj[obj] = true;
  }
  
  if (checkbox == "1") {
    var checkboxes = document.forms["form"].elements[check_obj];
    for (var i = 0; i < checkboxes.length; i++) {
      if (checkboxes[i].checked == true) {
        checkboxes[i].checked = false;
      } else {
        checkboxes[i].checked = true;
      }
    }
  }
}

</script>



</head> 

<body>
<div align="center"><img src="http://images.regiscope.com/logos/logo-211x75.jpg"  />
<div style="font-size:10px;">VERSION: <?php echo $version; ?> IP: <?php echo $ip = $_SERVER['REMOTE_ADDR'];?></div>
</div>

<div>
  <table width="85%" border="0" align="center" cellpadding="3" cellspacing="0">
    <tr>
      <td align="left" valign="top">
        <div align="center"><strong>Current Servers</strong><br />
          <input name="MAKE NEW" type="button" value="ADD NEW" onClick="ajaxpage('<?php echo $_SERVER['PHP_SELF'];?>?action=makenew','serverinfo');" />
        </div>
        <div style="height: 250px; width: 150px; overflow:auto;">
          <div id="systemlist"><img src="images/loading.gif" />
          </div>
        </div>
      </td>
      <td width="80%" align="left" valign="top">
        <div id="serverinfo" >
        </div>
      </td>
    </tr>
  </table>
</div>
<hr />
<div align="center"><strong>&copy; <?php echo date(Y); ?> Regiscope Digital Imaging</strong>

</div>


<script language="javascript">
function clearinfo(){
  setTimeout("ajaxpage('index.php?action=clearinfo','serverinfo')",500);
//  setTimeout('loadserver()',5500);
}
function loadserver(){
  setTimeout("ajaxpage('index.php?action=loadserver','systemlist')",1500);
//  setTimeout('loadserver()',5500);
}
loadserver();


/* verifyIP from javascriptsource.com */

function verifyIP (IPvalue,valuetype) 
{
  errorString = "";
  theName = "IPaddress";

  var ipPattern = /^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/;
  var ipArray = IPvalue.match(ipPattern);

  if (IPvalue == "0.0.0.0")
    errorString = errorString + theName + ': '+IPvalue+' is a special IP '+valuetype+' and cannot be used here.';
  else if (IPvalue == "255.255.255.255")
    errorString = errorString + theName + ': '+IPvalue+' is a special IP '+valuetype+' and cannot be used here.';
  if (ipArray == null)
    errorString = errorString + theName + ': '+IPvalue+' is not a valid IP '+valuetype+'.';
  else {
    for (i = 0; i < 4; i++) 
    {
      thisSegment = ipArray[i];
      if (thisSegment > 255) 
      {
        errorString = errorString + theName + ': '+IPvalue+' is not a valid IP '+valuetype+'.';
        i = 4;
      }
      if ((i == 0) && (thisSegment > 255)) 
      {
        errorString = errorString + theName + ': '+IPvalue+' is a special IP '+valuetype+' and cannot be used here.';
        i = 4;
      }
    }
  }
  extensionLength = 3;
  return errorString;
}


function validateNumeric(field) {
  var valid = "0123456789"
  var ok = "yes";
  var temp;
  for (var i=0; i<field.length; i++) {
    temp = "" + field.substring(i, i+1);
    if (valid.indexOf(temp) == "-1") ok = "no";
  }
  return ok;
}


function validateAlphaNumeric(field) {
  var valid = "_0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ";
  var ok = "yes";
  var temp;
  for (var i=0; i<field.length; i++) {
    temp = "" + field.substring(i, i+1);
    if (valid.indexOf(temp) == "-1") ok = "no";
  }
  return ok;
}

/**
 * DHTML email validation script. Courtesy of SmartWebby.com (http://www.smartwebby.com/dhtml/)
 */

function echeck(str) 
{

  var at="@"
  var dot="."
  var lat=str.indexOf(at)
  var lstr=str.length
  var ldot=str.indexOf(dot)
  if (str.indexOf(at)==-1){
     alert("Invalid E-mail ID")
     return false
  }

  if (str.indexOf(at)==-1 || str.indexOf(at)==0 || str.indexOf(at)==lstr){
     alert("Invalid E-mail ID")
     return false
  }

  if (str.indexOf(dot)==-1 || str.indexOf(dot)==0 || str.indexOf(dot)==lstr){
      alert("Invalid E-mail ID")
      return false
  }

   if (str.indexOf(at,(lat+1))!=-1){
      alert("Invalid E-mail ID")
      return false
   }

   if (str.substring(lat-1,lat)==dot || str.substring(lat+1,lat+2)==dot){
      alert("Invalid E-mail ID")
      return false
   }

   if (str.indexOf(dot,(lat+2))==-1){
      alert("Invalid E-mail ID")
      return false
   }
  
   if (str.indexOf(" ")!=-1){
      alert("Invalid E-mail ID")
      return false
   }

   return true					
}

/********************/

function removeF(c)
{
  jumper("index.php?action=remove&server="+c,"remove", "500");

  loadserver();
  return false;
}

function revokeF(c)
{
  jumper("index.php?action=revoke&server="+c,"remove", "500");

  loadserver();
  return false;
}
  
function installRevokeF(c)
{
  jumper("index.php?action=installRevoke&server="+c,"remove", "500");
//  loadserver();
  return false;
}

function saveVPNinfo() {
  var s=document.getElementById('servername').value;
  var serverdns=document.getElementById('serverdns').value;
  var port=document.getElementById('port').value;
  jumper("index.php?action=saveVPNinfo&server="+s+"&serverdns="+serverdns+
         "&port="+port+"","gennew","500");
  clearinfo();
  return false;
}

function gennew(advancedopts){
  var s=document.getElementById('servername').value;
  var newlocflag=document.getElementById('newlocflag').value;
  
  if(!s){
    alert('Please enter a server name');
    document.getElementById('servername').focus();
    return false;
  }
  if (validateAlphaNumeric(s) != "yes")
  {
    alert("Only letters and numbers are allowed for the server name");
    return false;
  }
    
    
  if (newlocflag) {
    var clientloc=document.getElementById('clientloc').value;
    var serverdns=document.getElementById('serverdns').value;
    var port=document.getElementById('port').value;
    
    if (advancedopts==2)
    {
      var username=document.getElementById('username').value;
      var password=document.getElementById('password').value;
      var authenticationmethod=document.getElementById('authenticationmethod').value;
      var httpproxyhost=document.getElementById('httpproxyhost').value;
      var httpproxyretry=document.getElementById('httpproxyretry').value;
      var httpproxytimeout=document.getElementById('httpproxytimeout').value;
      var httpproxyoption_version=document.getElementById('httpproxyoption_version').value;
      var httpproxyoption_agent=document.getElementById('httpproxyoption_agent').value;      
    }

    
    if(!clientloc){
      alert('Please enter a server location');
      document.getElementById('clientloc').focus();
      return false;
    }
    if (validateAlphaNumeric(clientloc) != "yes") 
    {
      alert("Only letters and numbers are allowed for the location name");
      return false;
    }

    a=validateNumeric(port);
    if (a != "yes")
    {
      alert("Invalid port, please reenter ");
      document.getElementById('port').focus();
      return false;
      }
    if (serverdns.length == 0)
    {
      alert("DNS Address must have a value");
      document.getElementById('serverdns').focus();
      return false;
    }
    if (advancedopts == 0)
    {
      jumper("index.php?action=gennew&server="+s+"&clientloc="+clientloc+"&serverdns="+serverdns+
             "&port="+port+"&newlocflag="+newlocflag+"","gennew","500");
    }
    if (advancedopts == 1)
    {
      jumper("index.php?action=advancedClient&server="+s+"&clientloc="+clientloc+"&serverdns="+serverdns+
             "&port="+port+"&newlocflag="+newlocflag+"","gennew","500");
      return false;
    }
    if (advancedopts == 2)
    {
      jumper("index.php?action=gennew&server="+s+"&clientloc="+clientloc+"&serverdns="+serverdns+
             "&port="+port+"&newlocflag="+newlocflag+
             "&username="+username+"&password="+password+"&authenticationmethod="+authenticationmethod+
             "&httpproxyhost="+httpproxyhost+"&httpproxyretry="+httpproxyretry+
             "&httpproxytimeout="+httpproxytimeout+"&httpproxyoption_version="+httpproxyoption_version+
             "&httpproxyoption_agent="+httpproxyoption_agent+"","gennew","500");
    }
    loadserver();
  } else
  {
    // New server
    var country=document.getElementById('country').value;
    var province=document.getElementById('province').value;
    var city=document.getElementById('city').value;
    var email=document.getElementById('email').value;
    var network=document.getElementById('network').value;
    var netmask=document.getElementById('netmask').value;
    var dnsaddress=document.getElementById('dnsaddress').value;
    var port=document.getElementById('port').value;
    var protocol=document.getElementById('protocol').value;
    var tuntap=document.getElementById('tuntap').value;
    var dhbits=document.getElementById('dhbits').value;
    var client2client=document.getElementById('client2client').value;
    var routeto=document.getElementById('routeto').value;
    var clientaccess=document.getElementById('clientaccess').value;
    var duplicatecn=document.getElementById('duplicatecn').value;
    var bridge=document.getElementById('bridge').value;
    var windows=document.getElementById('windows').value;
    var poolstart=document.getElementById('poolstart').value;
    var poolend=document.getElementById('poolend').value;
    
    if (advancedopts==2)
    {
      var fastio=document.getElementById('fastio').value;
      var multihome=document.getElementById('multihome').value;
      var mtudisc=document.getElementById('mtudisc').value;
      var mtutest=document.getElementById('mtutest').value;
      var mssfix=document.getElementById('mssfix').value;
      var fragment=document.getElementById('fragment').value;
      var verb=document.getElementById('verb').value;
    }

    
    if (country.length != 2)
    {
      alert("Country needs to be 2 characters long");
      document.getElementById('country').focus();
      return false;
    }
    if (province.length != 2)
    {
      alert("Province/State needs to be 2 characters long");
      document.getElementById('province').focus();
      return false;
    }
    if (city.length == 0)
    {
      alert("City cannot be zero length");
      document.getElementById('city').focus();
      return false;
    }
    if (!echeck(email))
    {
      return false;
    }
    
    
    if (dnsaddress.length == 0)
    {
      alert("DNS Address must have a value");
      document.getElementById('dnsaddress').focus();
      return false;
    }
    var a=verifyIP(network, "network");
    if (a.length > 0)
    {
      alert(a);
      document.getElementById('network').focus();
      return false;
    }
    var a=verifyIP(netmask, "netmask");
    if (a.length > 0)
    {
      alert(a);
      document.getElementById('network').focus();
      return false;
    }
    a=validateNumeric(port);
    if (a != "yes")
    {
      alert("Invalid port, please reenter");
      document.getElementById('port').focus();
      return false;
    }
    if (dhbits==2048)
    {
      a=confirm("This will take a very long time to generate.  Do you want to continue?");
      if (!a) return false;
    }
    
    if (bridge == "yes" & tuntap.substr(0,3) == "tun")
    {
      alert("Tun/Tap must be Tap or Tap-Static for bridging to work");
      return false;
    }
    if (advancedopts == 0)
    {
      jumper("index.php?action=gennewserver&server="+s+"&country="+country+"&province="+province+
             "&city="+city+"&email="+email+"&network="+network+"&netmask="+
             netmask+"&port="+port+"&dnsaddress="+dnsaddress+
             "&protocol="+protocol+"&tuntap="+tuntap+"&dhbits="+dhbits+
             "&client2client="+client2client+"&clientaccess="+clientaccess+
             "&duplicatecn="+duplicatecn+"&routeto="+routeto+"&bridge="+bridge+
             "&windows="+windows+"&poolstart="+poolstart+"&poolend="+poolend+"",
             "gennewserver","500");	
      loadserver();
    }
    if (advancedopts == 1)
    {
      jumper("index.php?action=advancedServer&server="+s+"&country="+country+"&province="+province+
             "&city="+city+"&email="+email+"&network="+network+"&netmask="+
             netmask+"&port="+port+"&dnsaddress="+dnsaddress+
             "&protocol="+protocol+"&tuntap="+tuntap+"&dhbits="+dhbits+
             "&client2client="+client2client+"&clientaccess="+clientaccess+
             "&duplicatecn="+duplicatecn+"&routeto="+routeto+"&bridge="+bridge+
             "&windows="+windows+"&poolstart="+poolstart+"&poolend="+poolend+"",
             "gennewserver", "500");
      return false;
    }
    if (advancedopts == 2)
    {
      jumper("index.php?action=gennewserver&server="+s+"&country="+country+"&province="+province+
             "&city="+city+"&email="+email+"&network="+network+"&netmask="+
             netmask+"&port="+port+"&dnsaddress="+dnsaddress+
             "&protocol="+protocol+"&tuntap="+tuntap+"&dhbits="+dhbits+
             "&client2client="+client2client+"&clientaccess="+clientaccess+
             "&duplicatecn="+duplicatecn+"&routeto="+routeto+"&bridge="+bridge+
             "&windows="+windows+"&poolstart="+poolstart+"&poolend="+poolend+
             "&fastio="+fastio+"&multihome="+multihome+"&mtudisc="+mtudisc+
             "&mssfix="+mssfix+"&fragment="+fragment+"&verb="+verb+
             "","gennewserver","500");	
      loadserver();
    }
  }
}
</script>
</body>
</html>


</script>
