<?php

/**
 * Project:     SmartyValidate: Form Validator for the Smarty Template Engine
 * File:        validate_criteria.isDNSAddress.php
 * Author:      Jonathan Bayer (Regiscope)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

/**
 * test if a value is a valid DNS address or IP address
 *
 * @param string $value the value being tested
 * @param boolean $empty if field can be empty
 * @param array params validate parameter values
 * @param array formvars form var values
 */
function smarty_validate_criteria_isNetAddress($value, $empty, &$params, &$formvars) 
{
  if (strlen($value) == 0 && $empty) return true;
//  if (gethostbyname($value) != $value) return true;
  if (getAddrByHost($value) != $value) return true;
  if (strlen($value) == 0) return false;
  
  if(isset($params['field2'])) 
  {
    if ($params['field2'] == "allowUnresolvable") return true;
  }
  
  $v = ip2long($value);
  if (!$v) 
  {
    return false;
  }
  $ar = explode(".", $value);
  if (sizeof($ar) != 4) return false;
  return true;
}

require_once('validate_criteria.isDNSAddress.php');

?>
