<?php
if (!defined ("LOCAL_SECURITY_KEY"))
 die ();

include_once ('include/openvpn-functions.inc');
include_once ('include/openssl-functions.inc');
include_once ('include/inifile-functions.inc');

global $Server;


openvpn_load_server_conf ();
if (!isset ($openvpn['Server'])) html_error ("The OpenVPN server has no configuration file");

openvpn_load_status ();
//if (!isset ($openvpn['Server']['Title'])) html_error ("2 The OpenVPN server has no status file");

openssl_load_database ();


$installed = file_exists($config['openvpn']['folder'] . "$Server.conf");
$rc = read_ini_file($config['Home'] . "/easy-rsa/keys/$Server/vars", $vars);
if (!$rc && isset($vars))
{
  //$port = $vars['']["PORT"];
  //$dnsaddress = $vars['']["DNS_ADDRESS"];
}

// load Smarty library
require_once('Smarty.class.php');
$smarty = new Smarty;


$smarty->assign  ('Servername',    $Server);
$smarty->assign  ('Installed',     $installed);
$smarty->assign  ('Port',          $port);
$smarty->assign  ('DNSAddress',    $dnsaddress);

// Mode
$smarty->assign  ('mode', $config['mode']);
    
// Decoration
$smarty->assign  ('Company_Name',  $config['Company_Name']);
$smarty->assign  ('Company_Logo',  $config['Company_Logo']);
$smarty->assign  ('URL_Home_Page', $config['URL_Home_Page']);
$smarty->assign  ('title',         'OpenVPN Web GUI : server configuration');

// Status Bar
$smarty->assign  ('Server',        $openvpn['Server']);
$smarty->assign  ('Seconds_Ago',   time () - $openvpn['Server']['Time']);

// Action
$smarty->assign  ('action',        'CONFIG');

// Action-Specific
if (isset ($openvpn['Client']))
 $smarty->assign ('Client',        $openvpn['Client']);
if (isset ($openssl['Server']))
 $smarty->assign ('Openssl',       $openssl['Server']);
if (isset ($openssl['Database']))
 $smarty->assign ('Certificates',  $openssl['Database']);

// Display
$smarty->assign  ('PluginPath',    $config['PluginsAbsolutePath']);
$smarty->assign  ('Plugins',       $config['Plugins']);
$smarty->assign  ('Page',          'action-config.tpl');
$smarty->display ('page.tpl');
?>
