<?php
if (!defined ("LOCAL_SECURITY_KEY"))
 die ();

include_once ('include/openvpn-functions.inc');
include_once ('include/openssl-functions.inc');

openvpn_load_server_conf ();
if (!isset ($openvpn['Server'])) html_error ("The OpenVPN server has no configuration file");

openvpn_load_status ();
//if (!isset ($openvpn['Server']['Title'])) html_error ("4 The OpenVPN server has no status file");

openssl_load_database ();

// Check permissions :)
//if (($sCertificateFile = openssl_get_filename ($GETid)) == '') html_error ("You are not authorized to download that certificate");

if (isset ($GETid))
{

  $requestID = $_REQUEST['id'];
  switch($requestID) {
    case "SH":
      $sFile = $openvpn['Server']['sh']['File'];
      $bFile = $openvpn['Server']['sh']['Exists'];
      if ($bFile)
      {
        include ('download-instructions.inc');
        exit;
      }
      break;
    case "MAC":
      $sFile = $openvpn['Server']['mac']['File'];
      $bFile = $openvpn['Server']['mac']['Exists'];
      if ($bFile)
      {
        include ('download-instructions.inc');
        exit;
      }
      break;
    case "ZIP":
      $sFile = $openvpn['Server']['zip']['File'];
      $bFile = $openvpn['Server']['zip']['Exists'];
      if ($bFile)
      {
        include ('download-instructions.inc');
        exit;
      }
      break;
      
    case "EXE":
      // load Smarty library
      require('Smarty.class.php');
      require_once('SmartyValidate.class.php');
      
      $smarty = new Smarty;
      $smarty->plugins_dir[] = "./SmartyValidate-2.9/plugins";

      include($config['PluginsAbsolutePath'].'win32installer/local.inc');
      include($config['PluginsAbsolutePath'].'win32installer/dl.inc');
      
      $filename = $config['Home'] . "windows/" . $Server . ".exe";
      @unlink($filename);
      
      if (win32installer_doPackage($config,$filename,$Server, $_REQUEST["ID"])===true)
      {
        $dir = $config['Home'] . "windows";
        if(!is_dir($dir) &&  !mkdir($dir,0700))
        {
          html_error("Unable to make Windows installation directory");
        }
        $fname = $Server.'-'.$_REQUEST["id"].'.exe';
        if (!rename($filename, $dir . "/" . $fname))
        {
          html_error("Unable to rename file, exiting");
          exit;
        }
      } else
      {
        $smarty->display('page.tpl');
        exit;
      }
      $sFile = $dir . "/" . $fname;
      $bFile = true;
      break;
    
    case "DH":
      $sFile = $openvpn['Server']['DH']['File'];
      $bFile = $openvpn['Server']['DH']['Exists'];
      break;
    case "CA":
      $sFile = $openssl['Server']['CA']['File'];
      $bFile = $openssl['Server']['CA']['Exists'];
      break;
    case "CRT":
      $sFile = $openvpn['Server']['Certificate']['File'];
      $bFile = $openvpn['Server']['Certificate']['Exists'];
      break;
    case "KEY":
      $sFile = $openvpn['Server']['Private_Key']['File'];
      $bFile = $openvpn['Server']['Private_Key']['Exists'];
      break;
    case "TLS":
      $sFile = $openvpn['Server']['TLS_Auth']['File'];
      $bFile = $openvpn['Server']['TLS_Auth']['Exists'];
      break;
//    case "CRL":
//      $sFile = $openvpn['Server']['CRL_Verify']['File'];
//      $bFile = $openvpn['Server']['CRL_Verify']['Exists'];
//      break;
      
    case 'conf':
      $sFile = $openvpn['Server']['Conf']['File'];
      $bFile = $openvpn['Server']['Conf']['Exists'];
      break;
    case 'ovpn':
      $sFile = $openvpn['Server']['Ovpn']['File'];
      $bFile = $openvpn['Server']['Ovpn']['Exists'];
      break;
    case 'CRL':
//      $temp = "/tmp/crl.pem";
//      exec($config['Home'] . "/scripts/build_crl_download.sh $Server $temp ",$thelist);
//      $sFile = $config['Home'];
//      $bFile = true;
      $sFile = $openvpn['Server']['CRL_Verify']['File'];
      $bFile = $openvpn['Server']['CRL_Verify']['Exists'];
      break;
    default:
      $sFile = '';
      $bFile = '';
      break;
  }
 
  if ($sFile != '')
    if ($bFile)
    if (is_readable ($sFile))
    {
      html_download ($sFile, basename ($sFile));
     } 
      else
        html_error ("Can't read the file '$sFile'.<br>Probably it should not be read by anybode except it's owner?");
    else
      html_error ("The file '$sFile' does not exist.");
  else
    html_error ('Wrong ID. Stop hacking.');
}
else
 html_error ('The ID is not defined. Stop hacking.');
?>
