<?php
if (!defined ("LOCAL_SECURITY_KEY"))
 die ();

#
#  All settings are read from /etc/openvpncertmgmt
#

require_once("include/inifile-functions.inc");
if (is_file("/etc/openvpncertmgmt.conf"))
{
  $rc = read_ini_file("/etc/openvpncertmgmt.conf", $confvars);
} else
{
  $rc = read_ini_file("../../setup/openvpncertmgmt.conf", $confvars);
}  
if (!$rc)
{
  echo "Missing configuration file, exiting<BR>";
  exit;
}

// OPENVPN-WEB-GUI ________________________

$config['mode'] = $confvars['']['MODE'];

// Authentication
$config['Authenticate'] = $confvars['']['AUTHENTICATE'];

$config['admin_users'] = $confvars['']['ADMIN_USERS'];

$config['auth']['pam_allow_login'] = $confvars['']['PAM_ALLOW_LOGIN'];
$config['auth']['ldap_allow_login'] = $confvars['']['LDAP_ALLOW_LOGIN'];

$config['auth']["ldap_host"] = $confvars['']['LDAP_HOST'];
$config['auth']["ldap_port"] = $confvars['']['LDAP_PORT'];
$config['auth']["ldap_version"] = $confvars['']['LDAP_VERSION'];
$config['auth']["ldap_base_dn"] = $confvars['']['LDAP_BASE_DN'];
$config['auth']["ldap_search_user"] = $confvars['']['LDAP_SEARCH_USER'];
$config['auth']["ldap_search_pass"] = $confvars['']['LDAP_SEARCH_PASS'];
$config['auth']["ldap_user_filter"] = $confvars['']['LDAP_USER_FILTER'];

$config['version'] = '0.1.3';
$config['www'] = $confvars['']['WWW'];
$config['smarty'] = $confvars['']['SMARTY']; 
$config['validate'] = $config['www'] . 'SmartyValidate-2.9/libs/';
$config['Home'] = $confvars['']['OPENVPNHOME'];
$config['Company_Name']          = $confvars['']['COMPANYNAME'];
$config['Company_Logo']          = $confvars['']['COMPANYLOGO'];
$config['URL_Home_Page']         = $confvars['']['URLHOMEPAGE'];


$config['AUTH_REALM']            = $config['Company_Name'] .' OpenVPN Web Management ' . $config['version'];
// What files to include into ZIP
$config['Download']['ZIP']['.pem']    = true;
$config['Download']['ZIP']['.key']    = true;
$config['Download']['ZIP']['.csr']    = false;
// All the following files should be placed into downloads folder
$config['Download']['ZIP']['Others']  = array ();
//$config['Download']['ZIP']['Others'] = array ('readme.txt', 'install.cmd', 'tls-auth.key');

// OPENVPN-WEB-GUI PLUG-INS _______________

// Use the real absolute path here.
$config['PluginsAbsolutePath'] = $config['www'] . 'plugins/';

// Plugins are configured automatically 

$rc = @exec("ls -1 " . $config['PluginsAbsolutePath'], $plugins);
if (!$rc)
{
  $config['Plugins'] = NULL;
} else
{
  foreach ($plugins as $p)
    $config['Plugins'][$p]['Folder'] = $p;
}




// OPENVPN ________________________________

// If the restart command is empty, the system will look in /etc/init.d/openvpn
// The openvpn folder MUST end with a slash
$config['openvpn']['folder']     = $confvars['']['OPENVPN'];
$config['openvpn']['restart']    = $confvars['']['RESTART'];
$config['openvpn']['stop'] = $confvars['']['STOP'];
$config['openvpn']['start'] = $confvars['']['START'];

$config['openvpn']['reload'] = $confvars['']['RELOAD'];
$config['openvpn']['softrestart'] = $confvars['']['SOFTRESTART'];
$config['openvpn']['condrestart'] = $confvars['']['CONDRESTART'];

$config['openvpn']['config']     = $config['openvpn']['folder'] .'none.conf';
$config['openvpn']['status']     = $config['openvpn']['folder'] .'openvpn-ws123-status.log';



// OPENSSL ________________________________

// Change: openssl keys directory
$config['openssl']['folder']     = '/etc/openvpn/keys/';
// Change: different folders for Public Certificates, Certificate Requests and Private Keys.
// NOTE: openssl somehow respects only newpem folder (for Public Certificates).
$config['openssl']['pubfolder']  = '/etc/openvpn/keys/newpem/';
$config['openssl']['reqfolder']  = '/etc/openvpn/keys/newpem/';
$config['openssl']['prvfolder']  = '/etc/openvpn/keys/newpem/';
// Change: openssl CA private and public keys
$config['openssl']['CA']['priv'] = 'file://'. $config['openssl']['folder'] .'ca.key';
$config['openssl']['CA']['pub']  = 'file://'. $config['openssl']['folder'] .'ca.crt';
// Change: openssl serial file
$config['openssl']['serial']     = $config['openssl']['folder'] .'serial';
// Change: openssl database
$config['openssl']['database']   = $config['openssl']['folder'] .'index.txt';
// Change: openssl configuration
$config['openssl']['config']     = array ('config'      => $config['Home'] .'easy-rsa/openssl.cnf',
                                          'encrypt_key' => 0);
$config['openssl']['config']     = array (
                                          'encrypt_key' => 0);
// NEW OPENSSL CERTIFICATE DEFAULTS _________

// Change all of them as it is done in your easy-rsa/vars
$config['openssl']['default']['expiration']             = 3560;
$config['openssl']['default']['countryName']            = 'US';
$config['openssl']['default']['stateOrProvinceName']    = 'Virginia';
$config['openssl']['default']['localityName']           = 'Chantilly';
$config['openssl']['default']['organizationName']       = 'Atomicorp';
$config['openssl']['default']['organizationalUnitName'] = 'Enter Department Name';
$config['openssl']['default']['commonName']             = 'Enter Server Name (no spaces)';
$config['openssl']['default']['emailAddress']           = 'Enter user@domain.com';



?>
