<?php
define ("LOCAL_SECURITY_KEY", true);

session_name ('openvpn-web-gui-session');
session_start ();

include_once ('config.inc');

set_include_path(get_include_path() . PATH_SEPARATOR . 
                 $config['www'] .PATH_SEPARATOR . $config['smarty'] . PATH_SEPARATOR . $config['validate']); //jbb

include_once ('include/functions.inc');

if (!isset ($_SESSION['username']))
{ session_defaults(); }
include('action-authenticate.inc');

check_authorize ();
load_plugins ();
global $Server;

$GETAction = (isset ($_REQUEST['Action']) ? ($_REQUEST['Action']) : 'Status');
$GETid     = (isset ($_REQUEST['id'])     ? ($_REQUEST['id'])     : NULL);
$Server    = (isset ($_REQUEST['server'])     ? ($_REQUEST['server'])     : NULL);

if (isset($GETid))
{
  switch ($GETAction)
  {
  case 'ViewCertificate':
    include ('action-viewcertificate.inc');
    break;
  case 'DownloadCertificate':
    include ('action-downloadcertificate.inc');
    break;
  case 'NewServer':
    include ('action-buildserver.inc');
    break;
  case 'NewClient':
    include ('action-buildclient.inc');
    break;
  case 'DownloadConfigFile':
    include ('action-downloadconfigfile.inc');
    break;
  default:
    foreach ($config['Plugins'] as $Plugin)
    {
      if ($GETAction == $Plugin['Action']['Name'] && isset ($Plugin['Action']['Include']))
      {
        include ('plugins/'. $Plugin['Folder'] .'/'. $Plugin['Action']['Include']);
        break;
      }
    }
    break;
  }
}
else
{
  switch ($GETAction)
  {
  case 'Logout':
    session_unset($_SESSION['session_id']);
    session_destroy();
    exit;

  case 'Install':
    include ('action-install.inc');
    break;
  case 'Status':
    include ('action-status.inc');
    break;
  case 'Servers':
    include ('action-servers.inc');
    break;
  case 'NewServer':
    include ('action-newserver.inc');
    break;
  case 'NewClient':
    include ('action-newclient.inc');
    break;
  case 'ServerManagement':
    echo '<script type="text/javascript" language="javascript">  window.location.replace("/openvpn/management");    </script>';
    break;
  case 'Config':
    include ('action-config.inc');
    break;
  case 'ListServers':
    include ('action-listservers.inc');
    break;
  case 'ClientManagement':
    include ('action-clientmanagement.inc');
    break;
  case 'DownloadFile':
    $sFile = $_REQUEST['file'];
    html_download ($sFile, basename ($sFile));

    break;
  default:
    foreach ($config['Plugins'] as $Plugin)
    {
      if ($GETAction == $Plugin['Action']['Name'] && isset ($Plugin['Action']['Include']))
      {
        include ('plugins/'. $Plugin['Folder'] .'/'. $Plugin['Action']['Include']);
        break;
      }
    }
    break;
  }
}
?>
