<?php
if (!defined ("LOCAL_SECURITY_KEY"))
  die ();

include_once ('include/openvpn-functions.inc');
include_once ('include/openssl-functions.inc');



$GETWhat = (isset ($_REQUEST['What']) ? ($_REQUEST['What']) : 'List');

if (substr($GETWhat, 0, 8) != "Download")
{
  openvpn_load_server_conf ();
  //if (!isset ($openvpn['Server'])) html_error ("The OpenVPN server has no configuration file");
  
  openvpn_load_status ();
  //if (!isset ($openvpn['Server']['Title'])) html_error ("The OpenVPN server has no status file");
  
  // load certifacte list
  openssl_load_database ();
}


// load local configuration
include_once ($config['PluginsAbsolutePath'] .'email/local.inc');


if (substr($GETWhat, 0, 8) != "Download")
{

  openvpn_find_connected ();
  $installed = file_exists($config['openvpn']['folder'] . "$Server.conf");
  
  
  for ($i = 0; $i < sizeof($openssl['Database']); $i++)
  {
    $d="-";
    $dash=strpos($openssl['Database'][$i]['CN'], $d, 0);
    if ($dash) {
      $dir = "clients/";
    }
    else $dir = "servers/";
    $f = $config['Home'] . $dir . $openssl['Database'][$i]['CN'] . ".conf";
    if (file_exists($f)) $openssl['Database'][$i]['Exists'] = true;
    else $openssl['Database'][$i]['Exists'] = false;
    $openssl['Database'][$i]['Installed'] = file_exists($config['openvpn']['folder'] . 
                $openssl['Database'][$i]['CN'] . ".conf");
    
  }  

}

// load Smarty library
require('Smarty.class.php');
require_once('SmartyValidate.class.php');
    
$smarty = new Smarty;
$smarty->plugins_dir[] = "./SmartyValidate-2.9/plugins";

global $Server;
global $openvpn;
global $openssl;

$smarty->assign  ('Servername', $Server);
$smarty->assign  ('Certificates',  $openssl['Database']);



// Inherited from the Web GUI project
$smarty->assign  ('Company_Name',  $config['Company_Name']);
$smarty->assign  ('Company_Logo',  $config['Company_Logo']);
$smarty->assign  ('URL_Home_Page', $config['URL_Home_Page']);
$smarty->assign  ('Server',        $openvpn['Server']);
$smarty->assign  ('Seconds_Ago',   time () - $openvpn['Server']['Time']);
$smarty->assign  ('PluginPath',    $config['PluginsAbsolutePath']);
$smarty->assign  ('Plugins',       $config['Plugins']);

// Action-specific. action and Page vars should reflect the plugin config.inc's corresponding ones
$smarty->assign  ('title',         'OpenVPN Web GUI : Email Config plugin');
$smarty->assign  ('OpenSSLStatus', openssl_check_functions ());
$smarty->assign  ('ZLibStatus',    zlib_check_functions ());
$smarty->assign  ('action',        'EMAIL');

switch ($GETWhat)
{
  case "List":
    
    if ( isset($config['Plugins']['win32installer']))
    {
      $smarty->assign  ('Win32installer', 'true');
    }
    $smarty->assign  ('Page',          'file:'. $config['PluginsAbsolutePath'] .'email/email-action.tpl');
    break;
    
  case "email":
    switch ($_REQUEST['type'])
    {
      case "ZIP":
        $fname = $Server . ".zip";
        break;
      case "SH":
        $fname = $Server . ".sh";
        break;
      case "MAC":
        $fname = $Server . ".mac.sh";
        break;
      case "EXE":
        
        include($config['PluginsAbsolutePath'].'win32installer/local.inc');
        include($config['PluginsAbsolutePath'].'win32installer/dl.inc');

        if (win32installer_doPackage($config,$filename,$Server, $_REQUEST["id"])===true)
        {
          $dir = $config['Home'] . "windows";
          if(!is_dir($dir) &&  !mkdir($dir,0700))
          {
            html_error("Unable to make Windows installation directory");
          }
          $fname = $Server.'-'.$_REQUEST["id"].'.exe';
          if (!rename($filename, $dir . "/" . $fname))
          {
            html_error("Unable to rename file, exiting");
            exit;
          }
        } else
        {
          $smarty->display('page.tpl');
          exit;
        }
    
        break;
      default:
        html_error ("Unknown Option");    
        break;
    }
    SmartyValidate::connect($smarty, true);
    SmartyValidate::register_validator('v_username','UserName','notEmpty');
    SmartyValidate::register_validator('v_email', 'EmailAddress', 'isEmail', false, false, 'trim');
    
    SmartyValidate::register_validator('v_encryptionKey', 'radioAction:encrypt:encryptionKey', 'isCheckedNotEmpty', false, false, 'trim');
    SmartyValidate::register_validator('v_password', 'radioAction:sendLink:thePassword', 'isCheckedNotEmpty', false, false, 'trim');
    
    $txt = @file_get_contents("downloads/" . $_REQUEST['type'] . ".txt");
    $smarty->assign  ("Message", $txt);
    
    $smarty->assign  ("DownloadFileName", $fname);
    $smarty->assign  ("thePassword", "");
    $smarty->assign  ("encryptionKey", "");
    $smarty->assign  ("radioAction", "sendLink");
    $smarty->assign  ('Page',          'file:'. $config['PluginsAbsolutePath'] .'email/email-entry.tpl');
    break;
    
  case "send":
    SmartyValidate::connect($smarty);
    if (!SmartyValidate::is_valid($_REQUEST))
    {
      $smarty->assign($_REQUEST);
      $smarty->assign  ("DownloadFileName", $_REQUEST['EmailFile']);
      if ($_REQUEST['radioAction'] == "sendLink") $smarty->assign  ("encryptionKey", "");
         else $smarty->assign  ("thePassword", "");
  
      $smarty->assign  ('Page',          'file:'. $config['PluginsAbsolutePath'] .'email/email-entry.tpl');
      $smarty->display('page.tpl');
      exit;
    }


    
    
    include($config['PluginsAbsolutePath'].'email/send.inc');
    break;
    
  case "DownloadLogin":
    include($config['PluginsAbsolutePath'].'email/login.inc');
    break;
    
  case "Download":
    include($config['PluginsAbsolutePath'].'email/download.inc');
    break;
}

// Display
$smarty->display ('page.tpl');
?>
