<?php
if (!defined ("LOCAL_SECURITY_KEY"))
 die ();

include_once ('include/openvpn-functions.inc');
include_once ('include/openssl-functions.inc');
openvpn_load_server_conf ();
if (!isset ($openvpn['Server'])) html_error ("The OpenVPN server has no configuration file");
openvpn_load_status ();
//if (!isset ($openvpn['Server']['Title'])) html_error ("The OpenVPN server has no status file");

openssl_load_database ();
openvpn_find_connected ();

// load Smarty library
require('Smarty.class.php');
$smarty = new Smarty;

global $Server;
$smarty->assign  ('Servername',        $Server);


// Subaction
$smarty->assign  ('subaction',  'revokecrt');
$smarty->assign  ('Company_Logo',  $config['Company_Logo']);
$smarty->assign  ('URL_Home_Page', $config['URL_Home_Page']);
$smarty->assign  ('Server',        $openvpn['Server']);
$smarty->assign  ('Seconds_Ago',   time () - $openvpn['Server']['Time']);
$smarty->assign  ('PluginPath',    $config['PluginsAbsolutePath']);
$smarty->assign  ('Plugins',       $config['Plugins']);

// Action-specific. action and Page vars should reflect the plugin config.inc's corresponding ones
$smarty->assign  ('title',         'OpenVPN Web GUI : Revoke Certificate');
$smarty->assign  ('action',        'CERTIFICATES');
$smarty->assign  ('Certificates',  $openssl['Database']);


if(isset($_REQUEST['Type'])) $revokecrt_type=$_REQUEST['Type'];
else $revokecrt_type='List';

if($revokecrt_type=='List'){
    $smarty->assign  ('Page',          'file:'. $config['PluginsAbsolutePath'] .'revokecrt/revoke-list.tpl');
}
elseif($revokecrt_type=='Confirm'){
    // Action-Specific
    $cntotal = count ($openssl['Database']);
    $GETidDEC = sscanf ($GETid, '%X');
    for ($j = 0; $j < $cntotal; $j++)
     if ($openssl['Database'][$j]['Serial'] == $GETid)
     {
      $openssl['Database'][$j]['ExpDate'] = str_openssldata_to_string ($openssl['Database'][$j]['ExpDate']);
      $openssl['Database'][$j]['RevDate'] = str_openssldata_to_string ($openssl['Database'][$j]['RevDate']);
      $smarty->assign ('Certificate',        $openssl['Database'][$j]);
      break;
     } 
    $smarty->assign  ('Page',          'file:'. $config['PluginsAbsolutePath'] .'revokecrt/revoke-confirm.tpl');

}
elseif($revokecrt_type=='Revoke'){
    openssl_revoke_crt ($GETid);
    //header('Location: '.$_SERVER["PHP_SELF"].'?Action=ViewCertificate&id='.$GETid);
    exit;
}
else {
// we should never be there
    $smarty->assign  ('Page',          'file:'. $config['PluginsAbsolutePath'] .'revokecrt/revoke-list.tpl');
}

// Display
$smarty->display ('page.tpl');

// There is no way to revoke certificate from PHP openssl extension, so need to call binary
function openssl_revoke_crt ($id)
{ 
  global $config;
  global $Server;
  global $smarty;
  global $config;
  
  
  // validate id
    if(!preg_match('/^[0-9A-F]+$/',$id)) die("openssl_revoke_crt: id incorrect");
    
    exec($config['Home'] . "/scripts/revoke_client.sh $Server $id",$thelist);
    
    $smarty->assign  ('thelist', $thelist);
    $smarty->assign  ('SubmitAction', 'Status');
    
    // Display
    $smarty->assign  ('PluginPath',    $config['PluginsAbsolutePath']);
    $smarty->assign  ('Plugins',       $config['Plugins']);
    $smarty->assign  ('Page',          'action-output.tpl');
  
    $smarty->display ('page.tpl');

}
?>
